/* 
        MaslXImage.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	original Ak5XImage.cc written by Daisuke Iizuka
        Copyright (c)1997 Daisuke Iizuka(iizuka@masada.t.u-tokyo.ac.jp)

	modified into MaslXImage by Yamahata for xmm
*/

#include <iostream.h>

#include <stdio.h>
//#include <cstdio>
#include <assert.h>
//#include <cassert>
#include <string.h>
//#include <cstring>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#ifdef MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif//MITSHM

#include "MaslXImage.h"

////////////////////////////////////////////////////////////////////////
// class MaslXNormalImage
////////////////////////////////////////////////////////////////////////

//
// 󥹥ȥ饯
//
MaslXNormalImage::MaslXNormalImage(Display* maslDisplay,Visual* maslVisual,
				   unsigned int maslDepth,
				   int maslWidth,int maslHeight):
  MaslXImage (maslDisplay,maslVisual,maslDepth,maslWidth,maslHeight)
{
  //pImageData=new unsigned char[width*height*bitPerPixel];
  // ximage=XCreateImage(display,visual,depth,ZPixmap,0,NULL,
  //		      width,height,(depth>8)?32:8,0);//,(depth>8)?32:8ưƤΤʤ
  ximage=XCreateImage(display,visual,depth,ZPixmap,0,NULL,
		      width,height,8,0);
  if (ximage==NULL)
    cerr << "can not allocate ximage.";

  length=ximage->bytes_per_line*height;
  pImageData=new char[length];
  memset (pImageData,0,length);
  ximage->data=pImageData;
}

//
// ǥȥ饯
//
MaslXNormalImage::~MaslXNormalImage ()
{
  delete[] pImageData;

  if (ximage!=NULL)
    {
      ximage->data = NULL;
      XDestroyImage(ximage);
    }
}

//
// Window or Pixmap ɽ
//
void MaslXNormalImage::XPutImage(Drawable drawable,GC gc,
				int srcX,int srcY,int destX,int destY,
				unsigned width,unsigned height)
{
  ::XPutImage(display,drawable,gc,ximage,srcX,srcY,destX,destY,width,height);
}


#ifdef MITSHM
////////////////////////////////////////////////////////////////////////
// class MaslXShmImage
////////////////////////////////////////////////////////////////////////

//
// 󥹥ȥ饯
//
MaslXShmImage::MaslXShmImage(Display* maslDisplay, Visual* maslVisual,
			     unsigned int maslDepth,
			     int maslWidth,int maslHeight):
  MaslXImage (maslDisplay,maslVisual,maslDepth,maslWidth,maslHeight)
{
  // XImage ¤Τ
  ximage=XShmCreateImage(display,visual,depth,ZPixmap,NULL,&shminfo,
			 width,height);

  // Shared memory segment 
  length=ximage->bytes_per_line * ximage->height;
  shminfo.shmid = shmget(IPC_PRIVATE, 
			 length,
			 IPC_CREAT | 0777);
  if (shminfo.shmid == -1) // ݼ
    perror("can not get MITSHM info.");

  // Shared memory segment  attach 
  pImageData=shminfo.shmaddr
    =ximage->data
    =shmat(shminfo.shmid, 0, 0);
  if ((int)(shminfo.shmaddr)==-1) // attach 
    perror("can not allocate MITSHM.");
  memset (pImageData,0,length);
  shminfo.readOnly = False; // X Server  shared memory 񤭹߲ǽ

  // X Server  shared memory ξΤ餻
  if ((iXShmAttach = XShmAttach(display, &shminfo)) == False) 
    perror("can not attach MITSHM.");
};


//
// ǥȥ饯
//
MaslXShmImage::~MaslXShmImage(void)
{
  // X Server  shared memory Ѥʤ褦
  if (iXShmAttach != False)
    XShmDetach(display, &shminfo);

  // Shared memory  detach 
  if ((int)(shminfo.shmaddr) != -1)
    shmdt(shminfo.shmaddr);

  // Shared memory 
  if (shminfo.shmid != -1)
    shmctl(shminfo.shmid, IPC_RMID, 0);

  // XImage ¤Τ
  ximage->data = NULL;  // Ѥ shared memory  free() ʤ褦ˤ
  XDestroyImage(ximage);
}


//
// Window or Pixmap ɽ
//
void MaslXShmImage::XPutImage(Drawable drawable,GC gc,
			     int srcX,int srcY,
			     int destX,int destY,
			     unsigned int width,unsigned int height)
{
  XShmPutImage(display,drawable,gc, ximage,srcX,srcY,destX,destY,
	       width,height,False);
}
#endif //MITSHM

// end MaslXImage.cc



