/* 
        MmsDebugMode.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/


#include "Mms.h"
#include "MmsDebugMode.h"
#ifdef DEBUG_MODE

Mms::MmsDebugMode::MmsDebugMode (const Mms* const mms,
				 const char* const scenarioStart,
				 const int scenarioLength,
				 const int* const intVar,
				 Bool isBreakMode=False,
				 const char* const maslTty=NULL):
  DebugMode (scenarioStart,scenarioLength,intVar,isBreakMode,maslTty),
  mms (mms)
{
  initializeScreen ();
}

Mms::MmsDebugMode::~MmsDebugMode ()
{
  //do nothing
}


void Mms::MmsDebugMode::printParam ()
{
  werase (paramWindow);
  wmove (paramWindow,1,1);
  wprintw (paramWindow,
	   "graphicMode=%d,",
	   (int) mms->getGraphicMode ());

  wprintw (paramWindow,
	   "Nak=%d,MmsPallet=%d,Pcm=%d\n ",
	   mms->getNumberOfNak (),
	   mms->getNumberOfMmsPalette (),
	   mms->getNumberOfPcm ());

  wprintw (paramWindow,
	   "curPalette=%3d,"
	   "lastDrawedNak=%3d\n ",
	   mms->getCurrentMmsPaletteNumber (),
	   mms->getLastDrawedNakNumber ());


  wprintw (paramWindow,
	   "time=%4d,waitFor=%4d(%4d/100Hz),"
	   "rate=%5dHz,"
	   "isAudioWriting=%d\n ",
	   mms->getNowCount (),
	   mms->getTimeCntForWait (),
	   mms->getTimeCounter (),
	   Audio::getSampleRate (),
	   mms->getIsAudioWriting ());

  box (paramWindow,0,0);
  mvwaddstr (paramWindow,0,LEFT_PADDING,"xmm:debug mode");

  wnoutrefresh (paramWindow);
}
#endif //DEBUG_MODE
