/* 
        NakStatic.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        codeshimarinwin maslβŸ򸵤Yamahata
        ޤ
*/
#include "NakStatic.h"

NakStatic::NakStatic (MaslInputStream& maslIs,const unsigned char mmsNakId):
  Nak (maslIs,mmsNakId),
  width (right-left+1),height (bottom-top+1)
{
  //width=right-left+1;
  //height=bottom-top+1;
  
  ///////memoryγݵڤӽ
  extractedImageData=new unsigned char[width*height];
  memset (extractedImageData,0,sizeof (unsigned char)*width*height);
  imageMask=new unsigned char[(width+7)*height/8];
  memset (imageMask,0,sizeof (unsigned char)*(width+7)*height/8);
  ///////dataŪŸ
  extractNakStatically (nakData,extractedImageData);
}

NakStatic::~NakStatic ()
{
  delete[] extractedImageData;
  delete[] imageMask;
}

void NakStatic::extractNak2Vram (unsigned char* const imageData,
				 const int x=0,const int y=0)
{
  int mmsOffset=x+y*VIRTUAL_VRAM_SIZE_X;
  for (int offset=0;offset<width*height;offset++)
    {
      if (isMaskSet (offset))//maskΩäƤ褹롣
	imageData[getAddress (offset)+mmsOffset]=extractedImageData[offset];
    }
}

void NakStatic::extractNakStatically (const unsigned char* const nakData,
				      unsigned char* imageData)
  // unsigned char* nakData ǡΥɥ쥹(Ƭ32ХȤξޤ)
  // unsigned char* imageData VRAMΥɥ쥹
  // int mmsOffset VRAMФ륪եå( y * 640 + x )
{
  const int backtrk[]=
  {
    2, 4, 8, 16, 638, 639, 640, 641,
    642, 1278, 1279, 1280, 1281, 1282, 2560, 5120
  };
  
  unsigned short nibble=255;// ¸˥֥(255=¸ʤ)

  const unsigned char* const lpBuffer1=nakData;// Хåե
  const unsigned char* const lpBuffer2=nakData+16;// Хåե
  const unsigned char* nakDataSrc=nakData+32;// ǡ
  //unsigned char* imageDataStart=imageData;
  address=0;
  int addressStart=0;
  
  unsigned short cmd;
  short c=0;
  for (;;)
    {
      cmd=*nakDataSrc++;
      if (cmd<208)
	{// ̤ξ꤫ñ̤ʣ
	  unsigned short subcmd=cmd%13;
	  unsigned short stlen;
	  switch (subcmd)
	    {
	    case 8:
	      stlen=getNibble (nakDataSrc,nibble)*2+9;
	      break;
	    case 9:
	      stlen=getNibble (nakDataSrc,nibble)*2+10;
	      break;
	    case 10:
	      stlen=(*nakDataSrc++)*2+41;
	      break;
	    case 11:
	      stlen=(*nakDataSrc++)*2+42;
	      break;
	    case 12:
	      stlen=*nakDataSrc++;
	      stlen+=(*(nakDataSrc++) << 8);
	      break;
	    default:
	      stlen=subcmd+1;
	      break;
	    }

	  /*
	    unsigned char* wp=imageData-backtrk[cmd/13];
	    for (int i=0;i<stlen*2;i++)
	    *imageData++=*wp++;
	    */
	  int wp=address-backtrk[cmd/13];
	  for (int i=0;i<stlen*2;i++)
	    {
	      putPoint (address,imageData[getOffset (wp)]);
	      address++;
	      wp++;
	    }

	  continue;
	}
      if (cmd<238)
	{
	  // ɥåȤʣ̤ʤ ( cmd < 223 )
	  // 1饹ΣɥåȤʣ̤ʤ ( cmd < 223 )
	  unsigned short n;

	  /*
	    unsigned char* wp=imageData;
	    wp -= ((cmd < 223)? 1 : 320)*2;
	    unsigned char low=*wp;
	    unsigned char hi=*(wp+1);
	    */
	  int wp=address;
	  wp -= ((cmd < 223)? 1 : 320)*2;
	  const unsigned char low=imageData[getOffset (wp)];
	  const unsigned char hi=imageData[getOffset (wp+1)];

	  switch (cmd)
	    {
	    case 208:
	    case 223:
	      /*
	       *imageData=low;
	       imageData++;
	       *imageData=low;
	       imageData++;
	       */
	      putPoint (address,low);
	      address++;
	      putPoint (address,low);
	      address++;
	      break;
	    case 209:
	    case 224:
	      /*
	       *imageData=hi;
	       imageData++;
	       *imageData=hi;
	       imageData++;
	       */
	      putPoint (address,hi);
	      address++;
	      putPoint (address,hi);
	      address++;
	      break;
	    case 210:
	    case 225:
	      /*
	       *imageData=hi;
	       imageData++;
	       *imageData=low;
	       imageData++;
	       */
	      putPoint (address,hi);
	      address++;
	      putPoint (address,low);
	      address++;
	      break;
	    case 211:
	    case 226:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=low;
	       imageData++;
	       *imageData=lpBuffer1[n];
	       imageData++;
	       */
	      putPoint (address,low);
	      address++;
	      putPoint (address,lpBuffer1[n]);
	      address++;
	      break;
	    case 212:
	    case 227:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=low;
	       imageData++;
	       *imageData=lpBuffer2[n];
	       imageData++;
	       */
	      putPoint (address,low);
	      address++;
	      putPoint (address,lpBuffer2[n]);
	      address++;
	      break;
	    case 213:
	    case 228:
	      /*
	       *imageData=low;
	       imageData++;
	       *imageData=*nakDataSrc;
	       imageData++;
	       nakDataSrc++;
	       */
	      putPoint (address,low);
	      address++;
	      putPoint (address,*nakDataSrc);
	      address++;
	      nakDataSrc++;
	      break;
	    case 214:
	    case 229:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=hi;
	       imageData++;
	       *imageData=lpBuffer1[n];
	       imageData++;
	       */
	      putPoint (address,hi);
	      address++;
	      putPoint (address,lpBuffer1[n]);
	      address++;
	      break;
	    case 215:
	    case 230:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=hi;
	       imageData++;
	       *imageData=lpBuffer2[n];
	       imageData++;
	       */
	      putPoint (address,hi);
	      address++;
	      putPoint (address,lpBuffer2[n]);
	      address++;
	      break;
	    case 216:
	    case 231:
	      /*
	       *imageData=hi;
	       imageData++;
	       *imageData=*nakDataSrc;
	       imageData++;
	       nakDataSrc++;
	       */
	      putPoint (address,hi);
	      address++;
	      putPoint (address,*nakDataSrc);
	      address++;
	      nakDataSrc++;
	      break;

	    case 217:
	    case 232:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=lpBuffer1[n];
	       imageData++;
	       *imageData=hi;
	       imageData++;
	       */
	      putPoint (address,lpBuffer1[1]);
	      address++;
	      putPoint (address,hi);
	      address++;
	      break;
	    case 218:
	    case 233:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=lpBuffer2[n];
	       imageData++;
	       *imageData=hi;
	       imageData++;
	       */
	      putPoint (address,lpBuffer2[n]);
	      address++;
	      putPoint (address,hi);
	      address++;
	      break;
	    case 219:
	    case 234:
	      /*
	       *imageData=*nakDataSrc;
	       imageData++;
	       nakDataSrc++;
	       *imageData=hi;
	       imageData++;
	       */
	      putPoint (address,*nakDataSrc);
	      address++;
	      nakDataSrc++;
	      putPoint (address,hi);
	      address++;
	      break;

	    case 220:
	    case 235:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=lpBuffer1[n];
	       imageData++;
	       *imageData=low;
	       imageData++;
	       */
	      putPoint (address,lpBuffer1[n]);
	      address++;
	      putPoint (address,low);
	      address++;
	      break;
	    case 221:
	    case 236:
	      n = getNibble(nakDataSrc, nibble);
	      /*
	       *imageData=lpBuffer2[n];
	       imageData++;
	       *imageData=low;
	       imageData++;
	       */
	      putPoint (address,lpBuffer2[n]);
	      address++;
	      putPoint (address,low);
	      address++;
	      break;
	    case 222:
	    case 237:
	      /*
	       *imageData=*nakDataSrc;
	       imageData++;
	       nakDataSrc++;
	       *imageData=low;
	       imageData++;
	       */
	      putPoint (address,*nakDataSrc);
	      address++;
	      nakDataSrc++;
	      putPoint (address,low);
	      address++;
	      break;
	    }
	}
      else
	{
	  unsigned short n1;
	  switch (cmd)
	    {
	    case 238:
	      /*
	       *imageData=lpBuffer1[((*nakDataSrc) & 0x0f)];
	       imageData++;
	       *imageData=lpBuffer1[((*nakDataSrc) >> 4)];
	       imageData++;
	       nakDataSrc++;
	       */
	      putPoint (address,lpBuffer1[((*nakDataSrc) & 0x0f)]);
	      address++;
	      putPoint (address,lpBuffer1[((*nakDataSrc) >> 4)]);
	      address++;
	      nakDataSrc++;
	      break;
	    case 239:
	      /*
	       *imageData=lpBuffer2[((*nakDataSrc) & 0x0f)];
	       imageData++;
	       *imageData=lpBuffer1[((*nakDataSrc++) >> 4)];
	       imageData++;
	       */
	      putPoint (address,lpBuffer2[((*nakDataSrc) & 0x0f)]);
	      address++;
	      putPoint (address,lpBuffer1[((*nakDataSrc) >> 4)]);
	      address++;
	      nakDataSrc++;
	      break;
	    case 240:
	      /*
	       *imageData=lpBuffer1[((*nakDataSrc) & 0x0f)];
	       imageData++;
	       *imageData=lpBuffer2[((*nakDataSrc++) >> 4)];
	       imageData++;
	       */
	      putPoint (address,lpBuffer1[((*nakDataSrc) & 0x0f)]);
	      address++;
	      putPoint (address,lpBuffer2[((*nakDataSrc) >> 4)]);
	      address++;
	      nakDataSrc++;
	      break;
	    case 241:
	      /*
	       *imageData=lpBuffer2[((*nakDataSrc) & 0x0f)];
	       imageData++;
	       *imageData=lpBuffer2[((*nakDataSrc++) >> 4)];
	       imageData++;
	       */
	      putPoint (address,lpBuffer2[((*nakDataSrc) & 0x0f)]);
	      address++;
	      putPoint (address,lpBuffer2[((*nakDataSrc) >> 4)]);
	      address++;
	      nakDataSrc++;
	      break;
	    case 242:	// ɤ򤽤Τޤ޽񤭹
	      /*
	       *imageData=*nakDataSrc++;
	       imageData++;
	       *imageData=*nakDataSrc++;
	       imageData++;
	       */
	      putPoint (address,*nakDataSrc);
	      address++;
	      nakDataSrc++;
	      putPoint (address,*nakDataSrc);
	      address++;
	      nakDataSrc++;
	      break;

	    case 243:	// ХȤΥɥ쥹*2­
	      /*
		imageData += *nakDataSrc;
		imageData += *nakDataSrc++;
		*/
	      address+=*nakDataSrc;
	      address+=*nakDataSrc++;
	      break;
	    case 244:	// ɤΥɥ쥹­
	      /*
		imageData += *(nakDataSrc)+(*(nakDataSrc+1) << 8);
		nakDataSrc += 2;
		*/
	      address+= *(nakDataSrc)+(*(nakDataSrc+1) << 8);
	      nakDataSrc+=2;
	      break;

	    case 245:
	      /*
	       *imageData=lpBuffer1[getNibble(nakDataSrc, nibble)];
	       imageData++;
	       imageData++;
	       */
	      putPoint (address,lpBuffer1[getNibble(nakDataSrc, nibble)]);
	      address+=2;
	      break;
	    case 246:
	      /*
	       *imageData=lpBuffer2[getNibble(nakDataSrc, nibble)];
	       imageData++;
	       imageData++;
	       */
	      putPoint (address,lpBuffer2[getNibble(nakDataSrc, nibble)]);
	      address+=2;
	      break;
	    case 247:
	      /*
	       *imageData=*nakDataSrc++;
	       imageData++;
	       imageData++;
	       */
	      putPoint (address,*nakDataSrc);
	      address+=2;
	      nakDataSrc++;
	      break;
	    case 248:
	      /*
		imageData++;
		*imageData=lpBuffer1[getNibble(nakDataSrc, nibble)];
		imageData++;
		*/
	      address++;
	      putPoint (address,lpBuffer1[getNibble(nakDataSrc, nibble)]);
	      address++;
	      break;
	    case 249:
	      /*
		imageData++;
		*imageData=lpBuffer2[getNibble(nakDataSrc, nibble)];
		imageData++;
		*/
	      address++;
	      putPoint (address,lpBuffer2[getNibble(nakDataSrc, nibble)]);
	      address++;
	      break;
	    case 250:
	      /*
		imageData++;
		*imageData=*nakDataSrc++;
		imageData++;
		*/
	      address++;
	      putPoint (address,*nakDataSrc);
	      address++;
	      nakDataSrc++;
	      break;

	    case 251:
	      n1 = lpBuffer1[getNibble(nakDataSrc, nibble)];
	      /*
	       *imageData=n1;
	       imageData++;
	       *imageData=n1;
	       imageData++;
	       */
	      putPoint (address,n1);
	      address++;
	      putPoint (address,n1);
	      address++;
	      break;
	    case 252:
	      n1 = lpBuffer2[getNibble(nakDataSrc, nibble)];
	      /*
	       *imageData=n1;
	       imageData++;
	       *imageData=n1;
	       imageData++;
	       */
	      putPoint (address,n1);
	      address++;
	      putPoint (address,n1);
	      address++;
	      break;
	    case 253:
	      n1 = *nakDataSrc++;
	      /*
	       *imageData=n1;
	       imageData++;
	       *imageData=n1;
	       imageData++;
	       */
	      putPoint (address,n1);
	      address++;
	      putPoint (address,n1);
	      address++;
	      break;
	    case 255:
				// 裱饦ɽλʺ磵饦ɤޤǡ
	      if (++c == 5) return;
	      nibble = 255;
	      //imageDataStart += 4000 * 16;
	      //imageData = imageDataStart;
	      addressStart+=4000*16;
	      address=addressStart;
	      break;
	    }
	}
    }
}
