/* 
        NakStatic.h

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        $B$3$N(Bcode$B$O(Bshimarin$B$5$s$N(Bwin masl$B$N2hA|E83+It$r85$K(BYamahata$B$,(B
        $B=$@5$7$^$7$?!#(B
*/
#include "MaslInputStream.h"
#include "Nak.h"
#ifndef nak_static_h
#define nak_static_h

class NakStatic:public Nak
{
private:
  const int width;
  const int height;
  unsigned char* extractedImageData;
  //$B@EE*$KE83+$7$?(Bdata$B$r3JG<$7$F$*$/$b$N(B
  unsigned char* imageMask;
  //image data$B$,$I$NItJ,$r=q$-49$($k$+3P$($F$*$/(B
  //imageMask$B$N@hF,$+$i?t$($F(Bxx$BHVL\$N(Bbit$B$,N)$C$F$$$?$i(B
  //98$B$N(BVRAM address xx$BHVL\$N2U=j$r=q$-49$($k(B
  //$BN)$C$F$$$J$+$C$?$i=q$-49$($J$$!#(B
  
  int getOffset (int address)
    {
      ///$B$^$:(Bvirtual vram$B$G$N:BI8$r=P$9!#(B
      const int x=address%VIRTUAL_VRAM_SIZE_X;
      const int y=address/VIRTUAL_VRAM_SIZE_X;
      //$B<B:]$K3NJ]$7$F$"$k(Bmemory$B>e$G$N0LCV$r=P$9!#(B
      return (x-left)+(y-top)*width;
    };
  int getAddress (int offset)
    {
      ///$B$^$:(Bvirtual vram$B$G$N:BI8$r=P$9!#(B
      const int x=left+(offset%width);
      const int y=top+offset/width;
      //const int y=offset/width;
      //const int x=offset-y*width;
      //virtual vram$B$G$N(Baddress$B$rJV$9(B
      return x+y*VIRTUAL_VRAM_SIZE_X;
    };
  void putPoint (int address,unsigned char color)
    {
      const int offset=getOffset (address);
      //data$B$r3P$($F$*$/(B
      extractedImageData[offset]=color;
      //$BIA2h$7$?$H$N(Bflag$B$rN)$F$k(B
      *(imageMask+(offset/8))|=(0x80 >> (offset%8));
    };
  Bool isMaskSet (int offset)
    {
      return (( (*(imageMask+(offset/8)))&(0x80 >> (offset%8)) )!=0);
    };

  //$B2hA|$NE83+$K;H$&(B
  int address;

  void extractNakStatically (const unsigned char* const nakData,
			     unsigned char* extractedImageData);
public:
  NakStatic (MaslInputStream& maslIs,const unsigned char mmsNakId);
  ~NakStatic ();
  void extractNak2Vram (unsigned char* const imageData,
			const int x=0,const int y=0);
  

};
#endif// nak_static_h
