/* 
        audio.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
//C++
#include <iostream.h>

//C
#include <stdio.h>
//#include <cstdio>
#include <unistd.h>
#include <sys/ioctl.h>
#include <fcntl.h>

//X
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "const.h"

#ifndef audio_h
#define audio_h

#ifndef NOAUDIO
# if defined (OPEN_SOUND_SYSTEM) && defined (__linux__)
#  include <sys/soundcard.h>
#  define SOUND_DEVICE "/dev/dsp"
//#define SOUND_DEVICE "/dev/audio"
//#define SOUND_DEVICE "/dev/pcaudio"
//#define SOUND_DEVICE "/dev/pcsp"
//soundcardʤƤdevice/dev/pcsp˻ꤹХԡ鲻Ф
//餷Ǥ̤ǧǤǧ줿餷𤪴ꤤޤ
//FreeBSDǤƱͤǤ
# elif defined (OPEN_SOUND_SYSTEM) && defined (__FreeBSD__)
#  include <machine/soundcard.h>
#  define SOUND_DEVICE "/dev/dsp"
# elif defined (OPEN_SOUND_SYSTEM) 
#  include <sys/soundcard.h>//Ŭ˽񤭴Ƥ
#  define SOUND_DEVICE "/dev/dsp"
# elif defined (sunos4) && !defined (NAS)
#  include <sun/audioio.h>
#  define SOUND_DEVICE "/dev/audio"
# elif defined (solaris) && !defined (NAS)
#  include <sys/audioio.h>
#  define SOUND_DEVICE "/dev/audio"
# elif defined (NAS) // for Network Audio System
#  include <audio/audio.h>
#  include <audio/audiolib.h>
#  include <audio/soundlib.h>
# endif
#endif


class Audio
{
  //variables
private:
  static int audio;//file descripter
  static int sampleRate;//=DEFAULT_SAMPLE_RATE;
  static Bool isDeviceOpened;//=False;//deviceopenƤ뤫
  //int bit;//sound bit
  //int rate;//sampling rate
  static Bool isAudioDisabled;//=False;//=True:audio̵,=False:audioͭ

#ifdef NAS  
protected:
  static AuServer* auServer; //audio server
private:
  static AuFlowID auFlow; //flow id
  static AuDeviceID auDevice; //device id
  static const unsigned char NUM_TRACKS;//number of tracks==1//mono:==2//stereo
  static Sound sound;
#endif

public:  
  //methods
private:
  static void printErrorDeviceIsNotOpened ();
public:
  static Bool openAudioDevice ();
  static int closeAudioDevice ();
  static Bool initializeAudioDevice (const int rate);
#ifdef NAS
  static void play (const unsigned char* const pcmData,int size,Bool isLoop);
#else
  static void play (const unsigned char* const pcmData,int size);
#endif
  static void resetAudioDevice ();
  static Bool setRate (const long rate);
  static int getNoBlockingSize ();
  static int getFragmentSize ();
  static int getSampleRate ();
  static void sync ();
  static void post ();

  //ʲaudioͭˤ뤫̵ˤ뤫Ǥ
  //deviceopen(openAudioDevice ()Ƥ)ˤѹʤǲ
  //openAudioDevice ()ƤϸƤФʤǲ
  //Ǥʤdevicecloseʤʤޤ
  //⤷ѹϰödevicecloseƤ
  //(closeAudioDevice ()ƤǤ)ˤƲ
  static void enableAudio ();
  static void disableAudio ();
  static Bool isAudioEnabled ();
};

#endif audio_h
