/* 
        audioNetworkAudioSystem.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#define USE_BUCKET//bucketȤäimplementˤ
//#undef USE_BUCKET//bucketȤäimplementˤʤ

#define NOAUDIO_FRAG_SIZE  8192
#define BUFFER_SIZE (NOAUDIO_FRAG_SIZE*8)
//ο˿̣ͭޤŬǤ
//ޤưʤʤѤƤߤɤ⡣

AuServer* Audio::auServer=NULL;
AuFlowID Audio::auFlow;
AuDeviceID Audio::auDevice=AuNone;
Sound Audio::sound=NULL;
#ifdef SURROUND
const unsigned char Audio::NUM_TRACKS=2;
#else
const unsigned char Audio::NUM_TRACKS=1;
#endif

Bool Audio::openAudioDevice ()
{
  if (isAudioDisabled)
    return True;
  
  char** returnStatus=NULL;
  auServer=AuOpenServer (NULL,0,NULL,0,NULL,returnStatus);
  if (auServer==NULL)
    {
      cerr << "can not connect audio server:" << returnStatus << endl;
      return False;
    }
  isDeviceOpened=True;

  //look for an output device
  for (int i=0;i<AuServerNumDevices(auServer);i++)
    {
      if ((AuDeviceKind(AuServerDevice(auServer,i))==
	   AuComponentKindPhysicalOutput) &&
	  AuDeviceNumTracks(AuServerDevice(auServer,i))==NUM_TRACKS)
	{
	  auDevice=AuDeviceIdentifier(AuServerDevice(auServer,i));
	  break;
	}
    }

    if (auDevice==AuNone)
      {
	cout << "can not find an output device" << endl;
	return False;
      }

    return True;
}

int Audio::closeAudioDevice ()
{
  if (isAudioDisabled)
    return True;

  AuStatus* returnStatus=NULL;
  AuDestroyFlow (auServer,auFlow,returnStatus);
  if (returnStatus!=NULL)
    {
      cout << "can not destroy flow.:";
      cout << returnStatus << endl;
      return False;
    }
  AuCloseServer (auServer);
  isDeviceOpened=False;
  return True;
}


Bool Audio::initializeAudioDevice (const int rate)
{
  if (isAudioDisabled)
    return True;

  if (!(isDeviceOpened))
    {//ޤaudio deviceopenƤʤä
      printErrorDeviceIsNotOpened ();
      return False;
    }

  sampleRate=rate;

  ////////////////////////making flow
  AuStatus* returnStatus=NULL;
  auFlow=AuCreateFlow(auServer,returnStatus);
  if (returnStatus!=NULL)
    {
      //cout << "Couldn't create flow.:" << returnStatus << endl;
      cout << "Couldn't create flow.:" << endl;
      return False;
    }

#ifndef USE_BUCKET
# ifdef SURROUND
  //////////////////////////constructing flow
  //surroundˤ롣
  //                              track[0]
  //              +------------------+
  //              |                  |
  //Cliant(mono data)             Bundle:element[2]==Device(stereo speaker)
  //element[0]    |                  |               element[3]
  //              +---Multi -1-------+
  //                  element[1]  track[1]
  AuElement element[4];
  AuInputTrack track[2];
  AuMakeElementImportClient(&element[0],sampleRate,AuFormatLinearUnsigned8,
			    1,
			    AuTrue,
			    BUFFER_SIZE,
			    //AuUnlimitedSamples,
			    NOAUDIO_FRAG_SIZE,//Ϻʤ
			    0, NULL);
  AuMakeInputTrack(&track[0],0,0);
  AuMakeElementMultiplyConstant (&element[1],0,
				 AuFixedPointFromFraction (-1,1));
  AuMakeInputTrack (&track[1],1,0);
  AuMakeElementBundle(&element[2],2,track);
  AuMakeElementExportDevice(&element[3],2,auDevice,sampleRate,
			    AuUnlimitedSamples,0,NULL);

  ///////////////////set flow
  AuSetElements(auServer,auFlow,AuTrue,4,element,NULL);
  
  ///////////////start flow
  AuStartFlow(auServer, auFlow, NULL);
# else
  //////////////////////////constructing flow
  //
  //Cliant(data)---Device(speaker)
  //element[0]     element[1]

  AuElement elements[2];
  AuMakeElementImportClient(&elements[0],sampleRate,AuFormatLinearUnsigned8,
			    NUM_TRACKS,
			    AuTrue,
			    BUFFER_SIZE,
			    //			    AuUnlimitedSamples,
			    NOAUDIO_FRAG_SIZE,//Ϻʤ
			    0, NULL);
  AuMakeElementExportDevice(&elements[1],0,auDevice,sampleRate,
			    AuUnlimitedSamples,0,NULL);

  ///////////////////set flow
  AuSetElements(auServer,auFlow,AuTrue,2,elements,NULL);

  ///////////////start flow
  AuStartFlow(auServer, auFlow, NULL);
# endif
#endif //#ifndef USE_BUCKET
  
  return True;
}


void Audio::play (const unsigned char* const pcmData,int size,Bool isLoop)
{
  if (isAudioDisabled)
    return;

#ifdef USE_BUCKET
# ifdef SURROUND
  AuStartFlow(auServer,auFlow,NULL);
  AuStatus* returnStatus=NULL;
  AuFlush (auServer);
  sound=SoundCreate (0,AuFormatLinearUnsigned8,
		     1,//mono
		     sampleRate,size,NULL);
  AuBucketID bucket=AuSoundCreateBucketFromData (auServer,sound,
						 (AuPointer) pcmData,
						 0,NULL,NULL);

  //////////////////////////constructing flow
  //surroundˤ롣
  //                              track[0]
  //              +------------------+
  //              |                  |
  //bucket(mono data)             bundle:element[2]==Device(stereo speaker)
  //element[0]    |                  |               element[3]
  //              +---Multi -1-------+
  //                  element[1]  track[1]
  AuElement element[4];
  AuInputTrack track[2];
#if 0
  if (isLoop)
    {//loop
      AuElementAction action;
      AuMakeChangeStateAction (&action,AuStateStop,AuStateStart,AuReasonEOF,
			       auFlow,AuElementAll,AuStateStart);
      AuMakeElementImportBucket (&element[0],sampleRate,bucket,size,0,
				 1,&action);
      
    }
  else
#endif
    {
      AuMakeElementImportBucket (&element[0],sampleRate,bucket,size,0,0,NULL);
    }
  AuMakeInputTrack(&track[0],0,0);
  AuMakeElementMultiplyConstant (&element[1],0,
				 AuFixedPointFromFraction (-1,1));
  AuMakeInputTrack (&track[1],1,0);
  AuMakeElementBundle(&element[2],2,track);
  AuElementAction action[2];
#if 0
  AuMakeSendNotifyAction (&(action[0]),AuStateStop,AuStateAny,AuReasonAny);
  AuMakeSendNotifyAction (&(action[1]),AuStatePause,AuStateAny,AuReasonAny);
  AuMakeElementExportDevice(&element[3],2,auDevice,sampleRate,
			    AuUnlimitedSamples,2,action);
#endif
  AuMakeElementExportDevice(&element[3],2,auDevice,sampleRate,
			    AuUnlimitedSamples,0,NULL);

  ///////////////////set flow

  AuSetElements(auServer,auFlow,AuTrue,4,element,NULL);
  AuStartFlow(auServer, auFlow, NULL);
  AuFlush (auServer);
  AuDestroyBucket (auServer,bucket,NULL);
# else//#ifdef SURROUND
  //ϥξ¤褦size;礭
  //fatal IO errorФߤ
  //cout << "write size=" << size << flush;
  sound=SoundCreate (0,AuFormatLinearUnsigned8,NUM_TRACKS,sampleRate,size,NULL);
  AuBucketID bucket=AuSoundCreateBucketFromData (auServer,sound,
						 (AuPointer) pcmData,
						 0,NULL,NULL);
#if 0
  if (isLoop)
    {
      AuSoundPlayFromBucket(auServer,bucket,auDevice,AuFixedPointFromSum(1,1),
			    NULL,NULL,32767,NULL,NULL,NULL,NULL);
      //loopΤǡ礭롼ײ˻ꡣ
    }
  else
#endif
    {
      AuSoundPlayFromBucket(auServer,bucket,auDevice,AuFixedPointFromSum(1,1),
			    NULL,NULL,1,NULL,NULL,NULL,NULL);
    }
  AuDestroyBucket (auServer,bucket,NULL);
  AuFlush (auServer);
  //cout << " done" << endl;
# endif//#ifdef SURROUND
#else //#ifdef USE_BUCKET
  //ϥξ¤褦size<=BUFFER_SIZE?
  //AuBadValue
  //cout << "write size=" << size << flush;
  AuWriteElement (auServer,auFlow,0,size,pcmData,AuFalse,NULL);
  AuFlush (auServer);
  //cout << " done" << endl;
#endif//#ifdef USE_BUCKET
}

void Audio::resetAudioDevice ()
{
  if (isAudioDisabled)
    return;
  
  ///󤳤ǤϤޤʤ
  //ɤˡΤäƤͤ鶵Ƥ
  int rate=getSampleRate ();
  AuStopFlow (auServer,auFlow,NULL);
  AuDestroyFlow (auServer,auFlow,NULL);
  initializeAudioDevice (rate);
}


Bool Audio::setRate (const long rate)
{
  //ɽˡϡ'rateP1'
  //εǽ  УãͤΥ졼ȤP1
  //   'rate16540' - 졼Ȥ򣱣ȣ
  //Υޥɤ¹ԤȡȯΣУãͤߤޤ
  if (isAudioDisabled)
    return True;

  //ߺflow˲롣
  //ɤˡΤäƤͤ鶵Ƥ
  AuStopFlow (auServer,auFlow,NULL);
  AuDestroyFlow (auServer,auFlow,NULL);

  return initializeAudioDevice (rate);
}

int Audio::getNoBlockingSize ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE;
  AuEvent auEvent;
  const int mode=AuEventsQueuedAlready;//ϻȤʤ
  //const int mode=AuEventsQueuedAfterReading;
  //const int mode=AuEventsQueuedAfterFlush;
  if (AuScanForTypedEvent (auServer,mode,AuTrue,AuEventTypeElementNotify,
			   &auEvent)==AuTrue)
    {
      AuElementNotifyEvent *notifyEvent=(AuElementNotifyEvent *)&auEvent;
#if 0
      cout << "notify event:";
      cout << "el_num=" << (int) notifyEvent->element_num;

      cout << " kind=";
      if (notifyEvent->kind==AuElementNotifyKindLowWater)
	cout << "lowWater";
      if(notifyEvent->kind==AuElementNotifyKindHighWater)
	cout << "highWater";
      if(notifyEvent->kind==AuElementNotifyKindState)
	cout << "state";

      cout << " prev_state=";
      if (notifyEvent->prev_state==AuStateStop)
	  cout << "stop";
      if (notifyEvent->prev_state==AuStateStart)
	  cout << "start";
      if (notifyEvent->prev_state==AuStatePause)
	  cout << "pause";
      
      cout << " cur_state=";
      if (notifyEvent->cur_state==AuStateStop)
	cout << "stop";
      if (notifyEvent->cur_state==AuStateStart)
	cout << "start";
      if (notifyEvent->cur_state==AuStatePause)
	  cout << "pause";
      
      cout << " reason=";
      if(notifyEvent->reason==AuReasonUser)
	cout << "user";
      if(notifyEvent->reason==AuReasonUnderrun)
	cout << "underrun";
      if(notifyEvent->reason==AuReasonOverrun)
	cout << "overrun";
      if(notifyEvent->reason==AuReasonEOF)
	cout << "eof";
      if(notifyEvent->reason==AuReasonWatermark)
	cout << "watermark";
      if(notifyEvent->reason==AuReasonHardware)
	cout << "hardare";
      cout << " num_bytes=" << notifyEvent->num_bytes << endl;
#endif //#if 0
      if (notifyEvent->cur_state==AuStateStop)
      	return NOAUDIO_FRAG_SIZE;
      if (notifyEvent->reason==AuReasonUnderrun)
      	return NOAUDIO_FRAG_SIZE;
      if (notifyEvent->cur_state==AuStatePause)
      	return NOAUDIO_FRAG_SIZE;
      if (notifyEvent->kind==AuElementNotifyKindLowWater)
	return notifyEvent->num_bytes;

      return 0;
      //return NOAUDIO_FRAG_SIZE;
    }

  //cout << "no event" << endl;
  return NOAUDIO_FRAG_SIZE;//ȸǤޤäƤޤġ
  //return 0;
}

int Audio::getFragmentSize ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE;

  return NOAUDIO_FRAG_SIZE;
}

int Audio::getSampleRate ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE*2;
  //*2ȸΤ
  //maslaudio.h maslaudo.ccǤsignal0.5֤ˤʤ褦ˤƤ롣
  //OSSdefaultǤʤ褦ʤΤǡ
  //ޤʤʤͤѤƸɤ⡢

  return sampleRate;
}



void Audio::sync ()
{
  if (isAudioDisabled)
    return;
  
  //ǤϲΤޤʤۤ˲ɤˡΤǤ礦?
  AuFlush (auServer);
  AuSync (auServer,AuFalse);
}

void Audio::post ()
{
  if (isAudioDisabled)
    return;
  
  return;
}

void Audio::enableAudio ()
{
  isAudioDisabled=False;
}

void Audio::disableAudio ()
{
  if (isDeviceOpened)
    closeAudioDevice ();
  
  isAudioDisabled=True;
}

Bool Audio::isAudioEnabled ()
{
  return !(isAudioDisabled);
}

void Audio::printErrorDeviceIsNotOpened ()
{
  cerr << "audio device is not opened." << endl;
  cerr << "before using audio,you must open audio device." << endl;
} 
