/* 
        audioOpenSoundSystem.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/

#define NOAUDIO_FRAG_SIZE  8192
//ο˿̣ͭޤŬǤ
//ޤưʤʤѤƤߤɤ⡣

Bool Audio::openAudioDevice ()
{
  //ϡbuffer fragmentsꤹ٤
  //ɤɤΤäʬäƤʤ
  if (isAudioDisabled)
    return True;
  
  audio=open (SOUND_DEVICE,O_WRONLY|O_NDELAY);
  //audio=open (SOUND_DEVICE,O_WRONLY);
  if (audio==-1)
    {
      perror("Can not open audio device.");
      return False;
    }
  isDeviceOpened=True;

#ifdef MIX_AUDIO
  //οϴĤˤΤɤΤǤ礦
  //֥줿ꡢϵդ˲ȿ٤ȤäˤϰʲοŬ
  //ƤߤƤ
  //֥줬->blockSize䤷Ƥߤ
  const int fragmentNumber=0x0004;
# ifdef SURROUND
  const int blockSize=0x000c;
# else
  const int blockSize=0x0006;
# endif
  int arg=(fragmentNumber << 16)|blockSize;
  if(ioctl (audio,SNDCTL_DSP_SETFRAGMENT,&arg)==-1)
    {
      perror("can not set fragment parameter.");
      return False;
    }
#endif

  return True;
}

int Audio::closeAudioDevice ()
{
  if (isAudioDisabled)
    return True;

  Bool tmp=(close (audio)==0);
  if (tmp)
    {//deviceclose褿
      isDeviceOpened=False;
      return tmp;
    }
  else
    {//devicecloseʤä
      perror ("can not close audio device.");
      return tmp;
    }
}


Bool Audio::initializeAudioDevice (const int rate)
{
  if (isAudioDisabled)
    return True;

  if (!(isDeviceOpened))
    {//ޤaudio deviceopenƤʤä
      printErrorDeviceIsNotOpened ();
      return False;
    }
  
  int bitPerSample=8;//8bit
  int format=AFMT_U8;//unsigned linear 8bit
#ifdef SURROUND //surroundϥƥ쥪Ǻ롣
  int channel=1;//channel mono=0,stereo=1
#else
  int channel=0;//channel mono=0,stereo=1
#endif
  sampleRate=rate;
  int tmp;

  tmp=bitPerSample;
  if ((ioctl (audio,SNDCTL_DSP_SAMPLESIZE,&bitPerSample))==-1)
    {
      perror ( "Unable to set audio smaple size. SNDCTL_DSP_SAMPLESIZE.");
      cerr << "bitPerSample=" << tmp << endl;
      cerr << "result=" << bitPerSample << endl;
      return False;
    }

  if (bitPerSample!=tmp)
    {//error check
      cerr << "Unable to set audio sample size." << endl;
      cerr << "bitPerSample=" << tmp << endl;
      cerr << "result=" << bitPerSample << endl;
      return False;
    }

  tmp=format;
  if ((ioctl (audio,SNDCTL_DSP_SETFMT,&format))==-1)
    {
      perror ("Unbale to set audio format. ANDCTL_DSP_SETFMT." );
      return False;
    }


  if (format!=tmp)
    {
      cerr << "Unbale to set audio format. SNDCTL_DSP_SETFMT." << endl;
      return False;
    }

  tmp=channel;
  if ((ioctl (audio,SNDCTL_DSP_STEREO,&channel))==-1)
    {
      perror ("Unable to set Mono/Stereo.");
      cerr << "channel=" << channel << endl;
      return False;
    }
  if (channel!=tmp)
    {
      cerr << "Unable to set Mono/Stereo." << endl;
      cerr << "channel=" << tmp<< endl;
      cerr << "result=" << channel << endl;
      return False;
    }
  
  tmp=sampleRate;
  if ((ioctl (audio,SNDCTL_DSP_SPEED,&sampleRate))==-1)
    {
      perror ("SNDCTL_DSP_SPEED");
      cerr << "rate=" << tmp << endl;
      return False;
    }
#ifndef NOCHECK_SAMPLE_RATE
  if (sampleRate!=tmp)
    {
/*
#ifdef DEBUG
      cerr << "rate=" << rate << ",tmp=" << tmp << endl;
#endif
*/
      cerr << "SNDCTL_DSP_SPEED:can not set playing rate strictly." << endl;
      cerr << "rate=" << tmp << endl;
      cerr << "result=" << sampleRate << endl;
      return False;
    }
#endif//NOCHECK_SAMPLE_RATE

/*
#ifdef DEBUG
  cerr << "sample rate=" << rate << endl;
#endif
*/
  return True;
}


void Audio::play (const unsigned char* const pcmData,int size)
{
  if (isAudioDisabled)
    return;
  
  write (audio,pcmData,size);
}
//ϤäȤȤ٤
//ơ̽񤭽Ф٤

void Audio::resetAudioDevice ()
{
  if (isAudioDisabled)
    return;

  ioctl (audio,SNDCTL_DSP_RESET,0);
}


Bool Audio::setRate (const long rate)
{
  //ɽˡϡ'rateP1'
  //εǽ  УãͤΥ졼ȤP1
  //   'rate16540' - 졼Ȥ򣱣ȣ
  //Υޥɤ¹ԤȡȯΣУãͤߤޤ
  if (isAudioDisabled)
    return True;

  resetAudioDevice ();
  if (!(closeAudioDevice ()))
    return False;

  if (!(openAudioDevice ()))
    return False;
    
  return initializeAudioDevice (rate);
}

int Audio::getNoBlockingSize ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE;

  audio_buf_info info;
  if (ioctl (audio,SNDCTL_DSP_GETOSPACE,&info)==-1)
    {
      perror ("can not get no bloking output size of audio");
      exit (-1);
    }
  return info.bytes;
}

int Audio::getFragmentSize ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE;

  int fragSize;
  if (ioctl (audio,SNDCTL_DSP_GETBLKSIZE,&fragSize)==-1)
    {
      perror ("can not get fragment size.");
      exit (-1);
    }

  return fragSize;
}

int Audio::getSampleRate ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE*2;
  //*2ȸΤ
  //maslaudio.h maslaudo.ccǤsignal0.5֤ˤʤ褦ˤƤ롣
  //OSSdefaultǤʤ褦ʤΤǡ
  //ޤʤʤͤѤƸɤ⡢

  return sampleRate;
}



void Audio::sync ()
{
  if (isAudioDisabled)
    return;
  
  if (ioctl (audio,SNDCTL_DSP_SYNC,0)==-1)
    {
      perror ("can not sync audio dev");
      exit (-1);
    }
}

void Audio::post ()
{
  if (isAudioDisabled)
    return;
  
  if (ioctl (audio,SNDCTL_DSP_POST,0)==-1)
    {
      perror ("can not post audio dev");
      exit (-1);
    }
}

void Audio::enableAudio ()
{
  isAudioDisabled=False;
}

void Audio::disableAudio ()
{
  if (isDeviceOpened)
    closeAudioDevice ();
  
  isAudioDisabled=True;
}

Bool Audio::isAudioEnabled ()
{
  return !(isAudioDisabled);
}

void Audio::printErrorDeviceIsNotOpened ()
{
  cerr << "audio device is not opened." << endl;
  cerr << "before using audio,you must open audio device." << endl;
} 
