/* 
        compile.cc

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 1998 Yamahata Isaku (ISA-9)
*/
#include "CommandHash.h"

void Mms::nextCommand (unsigned long& commandLength,Command*& command)
{//$B<!$N(Bcommand$B$K9T$/!#(B
  command->next=new Mms::Command ();
  command=command->next;
  commandLength++;
};

void Mms::math
(const char*& pt,unsigned long& commandLength,
 Mms::Command*& command,Mms::MmsCommandType type)
{
  pt++;//skip operator
  command->type=type;
  skipOneCharAndStoreValue (command,2,2);  //$B0z?t$r3P$($F$*$/!#(B
  nextCommand (commandLength,command);
}


void Mms::compile ()
{
  pt=scenario->getBeginPoint ();
  int nLeftBrackets=0;
  int nRightBrackets=0;
  int nLeftBraces=0;
  int nRightBraces=0;
  commandLength=0;
  for (int i=0;i<MAX_PAIR;i++)
    {
      brackets[i].left=NULL;
      brackets[i].right=NULL;
      braces[i].left=NULL;
      braces[i].right=NULL;
    }
  mmsCommand=new Command ();
  Command* command=mmsCommand;
  for (;;)
    {
      if (searchNextCommand ()==False)
	break;
	    
      command->pt=pt;//for debug mode
#if 0
      cerr << ":";
      cerr.write (pt,10);
      cerr << endl;
#endif
      if (islower (*pt))
	{
	  int length=1;
	  while (islower (pt[length]))
	    length++;
	  const COMMAND_TABLE* t=Perfect_Hash::in_word_set (pt,length);
	  if (t!=NULL)
	    {
	      command->type=t->type;//$B2?$N(Bcommand$B$+3P$($F$*$/(B
	      pt+=strlen (t->command);//command$B$NJ,$r?J$a$k!#(B
	      if (t->compile!=NULL)
		(this->*(t->compile)) (command);//$BFCJL$J=hM}$,I,MW!#(B
	      else
		storeValue (command,t->minParameter,t->maxParameter);//$BC1$K0z?t$r3P$($F$*$/!#(B
	      nextCommand (commandLength,command);//$B<!$N(Bcommand$B$N=`Hw(B
	    }
	}
      else
	{
	  switch (*pt)
	    {
	    case '[':
	      pt++;
	      //$B>r7oJ,4t$N$?$a$K0LCV$r3P$($F$*$/!#(B
	      brackets[nLeftBrackets].left=command;
	      compileLeftBracket (command,nLeftBrackets);
	      nLeftBrackets++;
	      nextCommand (commandLength,command);
	      continue;
	      break;
	    case ']':
	      pt++;
	      {
		if (nRightBrackets>=nLeftBrackets)
		  {//$B3g8L$NBP1~$,<h$l$F$$$J$$!#(B
		    cerr << "right bracket without left bracket.";
		    cerr << "'['=" << nLeftBrackets
			 << ",']'=" << nRightBrackets << endl;
		    cerr.write (pt-2,10);
		    cerr << endl;
		  }
		const int bracketNumber=
		  findAssBracNumber (nLeftBrackets,brackets);
	      //$B>r7oJ,4t$N$?$a$K0LCV$r3P$($F$*$/!#(B
		brackets[bracketNumber].right=command;
		compileRightBracket (command,bracketNumber);
	      }
	      nRightBrackets++;
	      nextCommand (commandLength,command);
	      continue;
	      break;
	    case '{':
	      pt++;
	      //$B>r7oJ,4t$N$?$a$K0LCV$r3P$($F$*$/!#(B
	      braces[nLeftBraces].left=command;
	      compileLeftBrace (command,nLeftBraces);
	      nLeftBraces++;
	      nextCommand (commandLength,command);
	      continue;
	      break;
	    case '}':
	      pt++;
	      {//$B3g8L$NBP1~$,<h$l$F$$$J$$!#(B
		if (nRightBraces>=nLeftBraces)
		  {
		    cerr << "right brace without left brace.";
		    cerr << "'{'=" << nLeftBraces
			 << ",'}'=" << nRightBraces << endl;
		    cerr.write (pt-2,10);
		  }
		const int braceNumber=
		  findAssBracNumber (nLeftBraces,braces);
	      //$B>r7oJ,4t$N$?$a$K0LCV$r3P$($F$*$/!#(B
		braces[braceNumber].right=command;
		compileRightBrace (command,braceNumber);
	      }
	      nRightBraces++;
	      nextCommand (commandLength,command);
	      continue;
	      break;
	    case '#':
	      command->type=tLABEL;
	      skipOneCharAndStoreValue (command,1,1);
	      nextCommand (commandLength,command);
	      break;
	    case '=':
	      math (pt,commandLength,command,tLET);
	      break;
	    case '+':
	      math (pt,commandLength,command,tPLUS);
	      break;
	    case '-':
	      math (pt,commandLength,command,tMINUS);
	      break;
	    case '*':
	      math (pt,commandLength,command,tTIMES);
	      break;
	    case '/':
	      math (pt,commandLength,command,tDIVIDE);
	      break;
	    case '%':
	      math (pt,commandLength,command,tMOD);
	      break;
	    case '&':
	      math (pt,commandLength,command,tAND);
	      break;
	    case '|':
	      math (pt,commandLength,command,tOR);
	      break;
	    case '^':
	      math (pt,commandLength,command,tXOR);
	      break;
	    case '\\':
	      goto SCENARIO_IS_END;
	      break;
	    default:
	      cerr << "ERROR:scenario is not right." << endl;
	      break;
	    }
	}
      //////////////////////////////////////////////////////error$B2sI|(B
      if (*pt=='@'||*pt=='.'||*pt=='\'')
	pt++;
      if (isdigit (*pt))
	searchnum ();
      while (*pt==' ' && *pt=='\t' && *pt=='\r' && *pt=='\n' && *pt==';' &&
	     !(scenario->isNotEnd (pt)))
	pt++;

      if (scenario->isEnd (pt))
	break;
    }

  //scenario$B=*N;!#(B
 SCENARIO_IS_END:
  command->type=tEND;
  if (nLeftBrackets!=nRightBrackets)
    {
      cerr << "unmatched brackets." << endl;
      cerr << "'['=" << nLeftBrackets << ",']'=" << nRightBrackets << endl;
    }
  
  if (nLeftBraces!=nRightBraces)
    {
      cerr << "unmatched braces." << endl;
      cerr << "'{'=" << nLeftBraces << ",'}'=" << nRightBraces << endl;
    }
}

void Mms::storeValue (Command* command,int minParameter,int maxParameter)
{//$B:GDc(BminParameter$B$NJ*$+$i>JN,$r5v$7$F(BmaxParameter$B$^$G0z?t$,$"$k!#(B
  //$B>JN,$5$l$?J*$O(B0$B$H8+$J$5$l$k!#(B
  Value* value=new Value[maxParameter];
  command->value=value;
  int i;
  Bool isDefault=False;//$B>JN,$5$l$?$+(B?
  if ((minParameter==0) && (!(isdigit (*pt))) && *pt!='-' &&
      *pt!='R' && *pt!='@' && *pt!= 'K' && *pt!='O' &&
      *pt!='P' && *pt!='F' && *pt!='T')
    isDefault=True;//$B0l$D$b0z?t$,$J$+$C$?!#(B
  for (i=0;i<maxParameter;i++)
    {
      if (isDefault==False)
	{
	  storeValue (value+i);
	  if (*pt!=',')//$B$^$@0z?t$,;D$C$F$$$k$+(B?
	    isDefault=True;
	  else
	    pt++;
	}
      else
	{//$B>JN,$5$l$?$N$G(B0$B$H8+$J$7$F(B0$B$r3P$($F$*$/!#(B
	  assert (i>=minParameter);
	  value[i].type=tDIGIT;
	  value[i].value=new int[1];
	  *(value[i].value)=0;
	}
    }
}

void Mms::storeValue (Value* value)
{//$B0l$D$NCM$r3P$($F$*$/!#(B
  switch (*pt)
    {
    case '-': //$B?t;z(B //$BD>2<$X(B
    case '0'://$BD>2<$X(B
    case '1'://$BD>2<$X(B
    case '2'://$BD>2<$X(B
    case '3'://$BD>2<$X(B
    case '4'://$BD>2<$X(B
    case '5'://$BD>2<$X(B
    case '6'://$BD>2<$X(B
    case '7'://$BD>2<$X(B
    case '8'://$BD>2<$X(B
    case '9':
      value->type=tDIGIT;
      value->value=new int[1];
      *(value->value)=searchnum ();
      break;
    case 'R'://R?($BMp?t(B)
      value->type=tRAND;
      value->value=new int[1];
      pt++;
      *(value->value)=searchnum ();
      break;
    case '@'://$BJQ?t(B
      pt++;
      storeVarValue (value);
      break;
    case 'K'://K?...(key$B<hF@(B)
      value->type=tKEY;
      pt++;
      storeKeyValue (value);
      break;
    case 'O'://o?(option)
      pt++;
      storeOptionValue (value);
      break;
    case 'P'://P(PCM$B$N>uBV(B)
      value->type=tPCM_STATE;
      value->value=NULL;
      pt++;
      break;
    case 'F'://F
      value->type=tF_STATE;
      value->value=new int[1];
      pt++;
      *(value->value)=searchnum ();
      break;
    case 'T'://T($B%?%$%^!<(B)
      value->type=tTIME;
      pt++;
      break;
    default:
      cerr << "ERROR:Mms::storeValue" << endl;
      break;
    }
}


void Mms::storeVarValue (Value* value)
{
  //@n:n$BHVL\$NFbItJQ?t(B
  //'@@n'$B$H$$$&5-=R$b2DG=!#!J(B'@@@n'$B$OIT2D!K(B
  //$B!!(B'@l*m','@l+n','@l*m+n'$B!J(Bm,n$B$N>l=j$K$O@0?t$N$_!K$H$$$&5-=R$b2DG=!#(B
  //$BNc!'(B'@0*2+1' - (0$BHV%l%8%9%?$NFbMF(B)*2+1
  //(@0)*2+1$B$G$"$j!"(B@(0*2)+1$B$d(B@(0*2+1)$B$G$O$J$$$N$GCm0U(B
  //'@@l*m','@@l+n','@@l*m+n'$B!J(Bm,n$B$N>l=j$K$O@0?t$N$_!K$H$$$&5-=R$b2DG=!#(B

  //l,m,n$B$HCM$,F~$k!#(B
  //*,+,-$B$,L5$$;~$O(Bm=1,n=0$B$H$J$k(B
  value->type=tVARIABLE;
  value->value=new int[3];

  if (*(pt)=='@')
    {//@@n$B$NBP:v(B
      pt++;
      value->type=tVAR_VARIABLE;
    }
  value->value[0]=searchnum ();
      
  value->value[1]=1;
  if (*(pt)=='*')
    {
      pt++;
      value->value[1]=searchnum ();
    }

  value->value[2]=0;
  if (*(pt)=='+'||*(pt)=='-')
    value->value[2]=searchnum ();
}

    
void Mms::storeKeyValue (Value* value)
{
  //length, key,... , '\0'$B$HCM$,F~$k!#(B
  int length=0;
  while (isdigit (*(pt+length)) || islower (*(pt+length)) ||
	 *(pt+length)=='R' || *(pt+length)=='S' || *(pt+length)=='T' ||
	 *(pt+length)=='F' || *(pt+length)=='A' || *(pt+length)=='B')
    length++;
  value->value=new int[length+2];
  value->value[0]=length;
  for (int i=1;i<length+1;i++)
    value->value[i]=*(pt++);
  value->value[length+1]='\0';
}

void Mms::storeOptionValue (Value* value)
{//case 'o':
  //$B!NI=5-J}K!!O!'(B'o?'
  //$B!N0UL#!O(B  $B!'(B?$B%*%W%7%g%s$,;XDj$5$l$F$$$l$P#1!"$5$l$F$J$1$l$P#0(B
  //$B!NNc!O(B   $B!'(B'oj' - $B5/F0;~$K(B'-j'$B%*%W%7%g%s$rIU$1$F$$$l$P#1!"IU$1$F$J$1$l$P#0(B
  //$B!t#2J8;zL\0J9_$O;2>H$7$^$;$s!#$D$^$j!"5/F0;~$KIU$1$F$$$?%*%W%7%g%s$,(B
  //'-j'$B$G$b(B'-ja'$B$G$b(B'-jz'$B$G$b!"(B'oj'$B$O#1$rJV$7$^$9!#(B
  //$B!NI=5-J}K!!O!'(B'o2?'
  //$B!N0UL#!O(B  $B!'(B?$B%*%W%7%g%s$G?t;z$,;XDj$5$l$F$$$l$P$=$N?t;z!"$=$l0J30$J$i$P#0(B
  //$B!NNc!O(B   $B!'(B'-o2a' - $B5/F0;~$K(B'-a256'$B$H$7$F$$$l$P#2#5#6$rJV$7!"(B
  //                 '-a'$B$rIU$1$F$J$+$C$?$j(B'-a'$B$@$1$J$i#0$rJV$9(B
  //$B!tIaDL$O(B'o?'$B$HJ;MQ$7$F;H$$$^$9!#(B
  //$B!NI=5-J}K!!O!'(B'o??'
  //$B!N0UL#!O(B  $B!'(B??$B%*%W%7%g%s$,;XDj$5$l$F$$$l$P#1!"$5$l$F$J$1$l$P#0(B
  //$B!NNc!O(B   $B!'(B'-oab' - '-ab'$B%*%W%7%g%s$rIU$1$F$$$l$P#1!"IU$1$F$J$1$l$P#0(B
  //$B!t(B'o?'$B$H0c$$!"FsJ8;zJ,$NG'<1$,2DG=$G$9!#(B

  //O2?
  //?$B$,F~$k(B
  if (*(pt)=='2')
    {//o2?
      pt++;
      value->type=tOPTION_VALUE;
      value->value=new int[1];
      *(value->value)=*(pt++);
      return;
    }

  if (isalnum (*(pt))&& !isalnum (*(pt+1)))
    {//o?
      //$B!)$,F~$k(B
      value->type=tOPTION;
      value->value=new int[1];
      *(value->value)=*(pt++);
      return;
    }
  else
    {//o??
      //?,?,$B$,F~$k(B
      value->type=tOPTION_DOUBLE;
      value->value=new int[2];
      *(value->value)=*(pt++);
      *(value->value)=*(pt++);
      return;
    }
  //$BDL>o$3$3$X$OMh$J$$(B
}




///////////////////////////////////////////////////specific
void Mms::storenValue (Value* value,const int n)
{//value$B$K#n8D$N0z?t$r3P$($F$*$/!#(B
  int i;
  for (i=0;i<n-1;i++)
    {
      storeValue (value+i);
      assert (*pt==',');//skip comma
      pt++;
    }
  storeValue (value+i);
}

inline static void storeSystem (Mms::Value* value,const int digit)
{
  value->type=Mms::tSYSTEM;
  value->value=new int[1];
  *(value->value)=digit;
}

void Mms::storeSystemAndValue (Command* command,const int value)
{
  command->value=new Mms::Value[3];//bracket$BHV9f(B value value
  storeSystem (command->value,value);
  storenValue (command->value+1,2);
}


void Mms::compileLeftBracket (Command* command,unsigned long nBrackets)
{
  switch (*pt)
    {
    case 'l'://[lP1
      command->type=tLEFT_BRACKET_LOOP;
      pt++;//skip 'l'
      command->value=new Value[3];//bracket$BHV9f(B loop$B2s?t(B loopCounter
      storeSystem (command->value,nBrackets);
      storenValue (command->value+1,1);
      storeSystem (command->value+2,-1);
      break;
    case '='://[=P1,P2
      command->type=tLEFT_BRACKET_IF_EQUAL;//bracket$BHV9f(B value value
      pt++;
      storeSystemAndValue (command,nBrackets);
      break;
    case '!'://[!P1,P2
      command->type=tLEFT_BRACKET_IF_NOT;//bracket$BHV9f(B value value
      pt++;
      storeSystemAndValue (command,nBrackets);
      break;
    case '>'://[>P1,P2
      command->type=tLEFT_BRACKET_IF_GRATER;//bracket$BHV9f(B value value
      pt++;
      if (*pt=='=')
	{//[>=P1,P2
	  command->type=tLEFT_BRACKET_IF_GRATER_EQUAL;
	  pt++;
	}
      storeSystemAndValue (command,nBrackets);
      break;
    case '<'://[<P1,P2
      command->type=tLEFT_BRACKET_IF_LESS;//bracket$BHV9f(B value value
      pt++;
      if (*pt=='=')
	{//[<=P1,P2
	  command->type=tLEFT_BRACKET_IF_LESS_EQUAL;
	  pt++;
	}
      storeSystemAndValue (command,nBrackets);
      break;
    default://[
      command->type=tLEFT_BRACKET;//bracket$BHV9f(B
      command->value=new Value[1];
      storeSystem (command->value,nBrackets);
      break;
    }
}

void Mms::compileRightBracket (Command* command,unsigned long nBrackets)
{
  switch (*pt)
    {
    case '='://]=P1,P2
      command->type=tRIGHT_BRACKET_IF_EQUAL;//bracket$BHV9f(B value value
      pt++;
      storeSystemAndValue (command,nBrackets);
      break;
    case '!'://]!P1,P2
      command->type=tRIGHT_BRACKET_IF_NOT;//bracket$BHV9f(B value value
      pt++;
      storeSystemAndValue (command,nBrackets);
      break;
    case '>'://]>P1,P2
      command->type=tRIGHT_BRACKET_IF_GRATER;//bracket$BHV9f(B value value
      pt++;
      if (*pt=='=')
	{//]>=P1,P2
	  command->type=tRIGHT_BRACKET_IF_GRATER_EQUAL;
	  pt++;
	}
      storeSystemAndValue (command,nBrackets);
      break;
    case '<'://]<P1,P2
      command->type=tRIGHT_BRACKET_IF_LESS;//bracket$BHV9f(B value value
      pt++;
      if (*pt=='=')
	{//]<=P1,P2
	  command->type=tRIGHT_BRACKET_IF_LESS_EQUAL;
	  pt++;
	}
      storeSystemAndValue (command,nBrackets);
      break;
    default://]
      command->type=tRIGHT_BRACKET;//bracket$BHV9f(B
      command->value=new Value[1];
      storeSystem (command->value,nBrackets);
      break;
    }
}

void Mms::compileLeftBrace (Command* command,unsigned long nBraces)
{
  switch (*pt)
    {
    case '='://{=P1,P2
      command->type=tLEFT_BRACE_IF_EQUAL;//brace$BHV9f(B value value
      pt++;
      storeSystemAndValue (command,nBraces);
      break;
    case '!'://{!P1,P2
      command->type=tLEFT_BRACE_IF_NOT;//brace$BHV9f(B value value
      pt++;
      storeSystemAndValue (command,nBraces);
      break;
    case '>'://{>P1,P2
      command->type=tLEFT_BRACE_IF_GRATER;//brace$BHV9f(B value value
      pt++;
      if (*pt=='=')
	{//{>=P1,P2
	  command->type=tLEFT_BRACE_IF_GRATER_EQUAL;
	  pt++;
	}
      storeSystemAndValue (command,nBraces);
      break;
    case '<'://{<P1,P2
      command->type=tLEFT_BRACE_IF_LESS;//brace$BHV9f(B value value
      pt++;
      if (*pt=='=')
	{//{<=P1,P2
	  command->type=tLEFT_BRACE_IF_LESS_EQUAL;
	  pt++;
	}
      storeSystemAndValue (command,nBraces);
      break;
    default://{
      command->type=tLEFT_BRACE;//brace$BHV9f(B
      command->value=new Value[1];
      storeSystem (command->value,nBraces);
      break;
    }
}

void Mms::compileRightBrace (Command* command,unsigned long nBraces)
{//}
  //brace$BHV9f(B
  command->type=tRIGHT_BRACE;
  command->value=new Value[1];//brace$BHV9f(B
  storeSystem (command->value,nBraces);
}

///////////////////////////////////////$B@)8f4XO"(B
Mms::Value* Mms::newAndStore3Value (const char*& pt,Command* command)
{
  command->value=new Mms::Value[3];
  storenValue (command->value,2);
  assert (*pt==' ');
  pt++;
  return command->value+2;
}
  
void Mms::compileJump (Command* command)
{
  Value* label=NULL;
  switch (*pt)
    {
    case '='://value value label$BHV9f(B
      command->type=tJUMP_IF_EQUAL;//jmp=P1,P2 P3
      pt++;
      label=newAndStore3Value (pt,command);
      break;
    case '!'://value value label$BHV9f(B
      command->type=tJUMP_IF_NOT;//jmp!P1,P2 P3
      pt++;
      label=newAndStore3Value (pt,command);
      break;
    case '>'://value value label$BHV9f(B
      command->type=tJUMP_IF_GRATER;//jmp>P1,P2 P3
      pt++;
      if (*pt=='=')
	{
	  command->type=tJUMP_IF_GRATER_EQUAL;//jmp>=P1,P2 P3
	  pt++;
	}
      label=newAndStore3Value (pt,command);
      break;
    case '<'://value value label$BHV9f(B
      command->type=tJUMP_IF_LESS;//jmp<P1,P2 P3
      pt++;
      if (*pt=='=')
	{
	  command->type=tJUMP_IF_LESS_EQUAL;//jmp<=P1,P2 P3
	  pt++;
	}
      label=newAndStore3Value (pt,command);
      break;
    default://label$BHV9f(B
      command->type=tJUMP;//jmpP1
      command->value=new Value[1];
      label=command->value;
      break;
    }
  storenValue (label,1);//jump$B@h$r3P$($F$*$/(B
}
     
void Mms::compileCall (Command* command)
{
  Value* label=NULL;
  switch (*pt)
    {
    case '=':
      command->type=tCALL_IF_EQUAL;//call=P1,P2 P3
      pt++;
      label=newAndStore3Value (pt,command);
      break;
    case '!':
      command->type=tCALL_IF_NOT;//call!P1,P2 P3
      pt++;
      label=newAndStore3Value (pt,command);
      break;
    case '>':
      command->type=tCALL_IF_GRATER;//call>P1,P2 P3
      pt++;
      if (*pt=='=')
	{//call>=P1,P2 P3
	  command->type=tCALL_IF_GRATER_EQUAL;
	  pt++;
	}
      label=newAndStore3Value (pt,command);
      break;
    case '<':
      command->type=tCALL_IF_LESS;//call>P1,P2 P3
      pt++;
      if (*pt=='=')
	{//call>=P1,P2 P3
	  command->type=tCALL_IF_LESS_EQUAL;
	  pt++;
	}
      label=newAndStore3Value (pt,command);
      break;
    default:
      command->type=tCALL;
      command->value=new Value[1];
      label=command->value;
      break;
    }
  storenValue (label,1);  //call$B@h$r3P$($F$*$/!#(B
}
     
//////////////////////////////////////////math
void Mms::compileSet (Command* command)
{
  //$B8D?t(B value,value,...
  //set@n,P1[,P2[,P3[,P4[,P5[,P6[,P7[,P8[,P9]]]]]]]]
  pt++;//skip @
  command->value=new Value[10];
  int length=0;
  for (length=0;length<10;length++)
    {
      storenValue (command->value+length,1);
      if (*pt!=',')
	break;
      pt++;
    }
  assert (length==*(command->value[1].value)+1);
}
      
  ////////////////////////////////////////graphi & pcm & etc...
void Mms::compileGetpara (Command* command)
{//getpara@n,P1
  pt++;
  storeValue (command,2,2);
}
      
void Mms::compilePointw (Command* command)
{//pointw@n,X1,Y1
  pt++;
  storeValue (command,3,3);
}
   
void Mms::compilePoint (Command* command)
{//point@n,X1,Y1
  pt++;
  storeValue (command,3,3);
}

void Mms::skipOneCharAndStoreValue
(Command* command,int minParameter,int maxParameter)
{
  pt++;
  storeValue (command,minParameter,maxParameter);
}
