/* 
        mmsPlay.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarincode򸵤YamahataľʪǤ
	ޤcommentˤKunidocumentѤƤʬͭޤ

*/

#include "Mms.h"
#include "MaslAudio.h"
#include "audio.h"
#include "MmsPalette.h"
#include "Nak.h"
#include "CopyImage2Root.h"

/*
*masl˹Ԥʤѿν
*audio deviceopenԤʤ
*/
void Mms::preparePlay ()
{
  pt=scenario->getBeginPoint ();
  ipCommand=mmsCommand;
  makeExecuteTable ();
  numberOfStack=0;
  
  timer.reset ();
  timeCntForWait=0;
  isTimerWaiting=False;
  isDispWaiting=False;

  //aheadlyExtractedNakNumber=-1;
  //delete nakAhead;
  //nakAhead=NULL;

  isAudioWriting=0;
  isAudioWaiting=0;

  nPalette=0;
  nNak=0;
  
  numberOfLoop=0;
  
  //defaultgraphic modeϲΤʤ
  //mmsWindow->setGraphicMode (GM320x200);
  //mmsWindow->setGraphicMode (GM640x400);
  //mmsWindow->setGraphicMode (GM320x240);
  mmsWindow->setGraphicMode (GM640x480);

#ifdef DEBUG_MODE
  if (xmmsOption.isDebugMode)
    debugMode=new MmsDebugMode (this,
				scenario->getBeginPoint (),
				scenario->getScenarioSize ()-
				(scenario->getBeginPoint ()-
				 scenario->getScenarioTop ()),
				intVar,xmmsOption.isBreakMode,
				xmmsOption.ttyOfDebugMode);//debug modeν
#endif//DEBUG_MODE


  ////////////////////////////audio device open
  if (numberOfPcm>0)
    {
      if (!(MaslAudio::openAudioDevice ()))
	{
	  cerr << "masl:can not open audio device." << endl;
	  cerr << "continue playing data with no audio." << endl;
	  MaslAudio::disableAudio ();
	}
      //ϤäɤΤʤ̵ɤ⡢
      //sample rateꤷƤʤΤͭ褦
      if (!(MaslAudio::initializeAudioDevice (DEFAULT_SAMPLE_RATE)))
	{
	  cerr << "masl:can not initialize PCM rate." << endl;
	  cerr << "may play audio with wrong sampling rate." << endl;
	}
    }
  else
    {//PCM data̵Τaudio̵ˤƤ
      MaslAudio::disableAudio ();
    }
  MaslAudio::prepareMaslAudio (&isAudioWriting,&isAudioWaiting);
}

/*
*audio deviceclose
*
*/
void Mms::afterPlay ()
{
  ///////////////////////sound deviceclose
  MaslAudio::offAudioTimer ();
  if (MaslAudio::isAudioEnabled ())
    MaslAudio::closeAudioDevice ();

  if (xmmsOption.isPause)//λkeyԤ򤹤
    {
      XEvent tmpEvent;
      for (;;)
	{
	  XNextEvent (display,&tmpEvent);
	  if (tmpEvent.type==KeyPress)//key줿齪λ
	    break;
	  updateWindow ();//ʳʤ
	}
    }

#ifdef DEBUG_MODE
  if (xmmsOption.isDebugMode)
    delete debugMode;//////debug modeθ
#endif//DEBUG_MODE
}


Bool Mms::play ()
{
  if (timer.isNotStarted ())
    timer.start ();
  
  for (;;)
    {
#ifndef USE_OLD_TIMER_WAIT
      if (waitTimerOrHandleEvent ()==False)
	return False;
#else
      ////////////////////////////////////////////////////////Xevent
      ///ConnectionNumber(display)selectȤ٤
      if (XCheckMaskEvent (display,maslEventMask,&event))
	{
	  if (handleEvent (event)==False)
	    return False;
	}
# ifdef DEBUG_MODE
      ////////////////////////////////////////////////////////debug mode
      if (xmmsOption.isDebugMode)
	debugMode->updataParam ();//debug modedataι(keyԤϤʤ)
# endif //DEBUG_MODE
#endif //#if USE_OLD_TIMER_WAIT


      ///////////////////////////////////////////////////////PCMԤ
      if (isAudioWaiting!=0)
	{
	  //cerr << "isAudioWaiting=" << (int) isAudioWaiting << endl;
	  //cerr << "isAudioWriting=" << (int) isAudioWriting << endl;
#ifdef MIX_AUDIO
	  if ((isAudioWriting & isAudioWaiting)!=0)
#else
	  if (isAudioWriting!=0)
#endif
	    {
	      //continue;
	      return True;
	    }
#ifdef MIX_AUDIO
	  //do nothing
#else
	  MaslAudio::sync ();
#endif
	  isAudioWaiting=0;
	}
      
#ifdef USE_OLD_TIMER_WAIT
      ///////////////////////////////////////////////timerϢ(timer countԤ)
      if (isTimerWaiting)
	{//timerԤ
	  if (timer.getNowCount ()<(long)timeCntForWait*100)
	    {//timerԤʤΤǡ롣
	      //continue;
	      return True;
	    }

	  //timerԤλ
	  timeCntForWait=0;
	  isTimerWaiting=False;
	  if (isDispWaiting)
	    {
	      updateWindowByTransferedData ();
	      isDispWaiting=False;
	    }
	}
#endif //#if USE_OLD_TIMER_WAIT


#ifdef DEBUG_MODE
      ////////////////////////////////////////debug mode
      if (xmmsOption.isDebugMode)
	debugMode->printData (ipCommand->pt);//debug modeɽ(keyԤ⤹)
#endif //DEBUG_MODE

      //switchȤä㴳®褦
#if 0
      execute[ipCommand->type] (ipCommand);//commandμ¹
      if (ipCommand->type==tEND)//\:scenarioνλ
	return False;
#else
      switch (ipCommand->type)
	{
	case tLEFT_BRACKET:
	  cmdLEFT_BRACKET (ipCommand);
	  break;
	case tLEFT_BRACKET_LOOP:
	  cmdLEFT_BRACKET_LOOP (ipCommand);
	  break;
	case tLEFT_BRACKET_IF_EQUAL:
	  cmdLEFT_BRACKET_IF_EQUAL (ipCommand);
	  break;
	case tLEFT_BRACKET_IF_NOT:
	  cmdLEFT_BRACKET_IF_NOT (ipCommand);
	  break;
	case tLEFT_BRACKET_IF_GRATER:
	  cmdLEFT_BRACKET_IF_GRATER (ipCommand);
	  break;
	case tLEFT_BRACKET_IF_GRATER_EQUAL:
	  cmdLEFT_BRACKET_IF_GRATER_EQUAL (ipCommand);
	  break;
	case tLEFT_BRACKET_IF_LESS:
	  cmdLEFT_BRACKET_IF_LESS (ipCommand);
	  break;
	case tLEFT_BRACKET_IF_LESS_EQUAL:
	  cmdLEFT_BRACKET_IF_LESS_EQUAL (ipCommand);
	  break;
	case tRIGHT_BRACKET:
	  cmdRIGHT_BRACKET (ipCommand);
	  break;
	case tRIGHT_BRACKET_IF_EQUAL:
	  cmdRIGHT_BRACKET_IF_EQUAL (ipCommand);
	  break;
	case tRIGHT_BRACKET_IF_NOT:
	  cmdRIGHT_BRACKET_IF_NOT (ipCommand);
	  break;
	case tRIGHT_BRACKET_IF_GRATER:
	  cmdRIGHT_BRACKET_IF_GRATER (ipCommand);
	  break;
	case tRIGHT_BRACKET_IF_GRATER_EQUAL:
	  cmdRIGHT_BRACKET_IF_GRATER_EQUAL (ipCommand);
	  break;
	case tRIGHT_BRACKET_IF_LESS:
	  cmdRIGHT_BRACKET_IF_LESS (ipCommand);
	  break;
	case tRIGHT_BRACKET_IF_LESS_EQUAL:
	  cmdRIGHT_BRACKET_IF_LESS_EQUAL (ipCommand);
	  break;
     	                                               
	case tLEFT_BRACE:
	  cmdLEFT_BRACE (ipCommand);
	  break;
	case tLEFT_BRACE_IF_EQUAL:
	  cmdLEFT_BRACE_IF_EQUAL (ipCommand);
	  break;
	case tLEFT_BRACE_IF_NOT:
	  cmdLEFT_BRACE_IF_NOT (ipCommand);
	  break;
	case tLEFT_BRACE_IF_GRATER:
	  cmdLEFT_BRACE_IF_GRATER (ipCommand);
	  break;
	case tLEFT_BRACE_IF_GRATER_EQUAL:
	  cmdLEFT_BRACE_IF_GRATER_EQUAL (ipCommand);
	  break;
	case tLEFT_BRACE_IF_LESS:
	  cmdLEFT_BRACE_IF_LESS (ipCommand);
	  break;
	case tLEFT_BRACE_IF_LESS_EQUAL:
	  cmdLEFT_BRACE_IF_LESS_EQUAL (ipCommand);
	  break;
	case tRIGHT_BRACE:
	  cmdRIGHT_BRACE (ipCommand);
	  break;
	case tELSE:
	  cmdELSE (ipCommand);
	  break;
	case tLABEL:
	  cmdLABEL (ipCommand);
	  break;
	case tJUMP:
	  cmdJUMP (ipCommand);
	  break;
	case tJUMP_IF_EQUAL:
	  cmdJUMP_IF_EQUAL (ipCommand);
	  break;
	case tJUMP_IF_NOT:
	  cmdJUMP_IF_NOT (ipCommand);
	  break;
	case tJUMP_IF_GRATER:
	  cmdJUMP_IF_GRATER (ipCommand);
	  break;
	case tJUMP_IF_GRATER_EQUAL:
	  cmdJUMP_IF_GRATER_EQUAL (ipCommand);
	  break;
	case tJUMP_IF_LESS:
	  cmdJUMP_IF_LESS (ipCommand);
	  break;
	case tJUMP_IF_LESS_EQUAL:
	  cmdJUMP_IF_LESS_EQUAL (ipCommand);
	  break;
	case tCALL:
	  cmdCALL (ipCommand);
	  break;
	case tCALL_IF_EQUAL:
	  cmdCALL_IF_EQUAL (ipCommand);
	  break;
	case tCALL_IF_NOT:
	  cmdCALL_IF_NOT (ipCommand);
	  break;
	case tCALL_IF_GRATER:
	  cmdCALL_IF_GRATER (ipCommand);
	  break;
	case tCALL_IF_GRATER_EQUAL:
	  cmdCALL_IF_GRATER_EQUAL (ipCommand);
	  break;
	case tCALL_IF_LESS:
	  cmdCALL_IF_LESS (ipCommand);
	  break;
	case tCALL_IF_LESS_EQUAL:
	  cmdCALL_IF_LESS_EQUAL (ipCommand);
	  break;
	case tRET:
	  cmdRET (ipCommand);
	  break;
	case tDELRET:
	  cmdDELRET (ipCommand);
	  break;
	case tMMSLOAD:
	  cmdMMSLOAD (ipCommand);
	  break;
	case tMMSCALL:
	  cmdMMSCALL (ipCommand);
	  break;
	case tMMSRET:
	  cmdMMSRET (ipCommand);
	  break;
	case tLET:
	  cmdLET (ipCommand);
	  break;
	case tPLUS:
	  cmdPLUS (ipCommand);
	  break;
	case tMINUS:
	  cmdMINUS (ipCommand);
	  break;
	case tTIMES:
	  cmdTIMES (ipCommand);
	  break;
	case tDIVIDE:
	  cmdDIVIDE (ipCommand);
	  break;
	case tMOD:
	  cmdMOD (ipCommand);
	  break;
	case tAND:
	  cmdAND (ipCommand);
	  break;
	case tOR:
	  cmdOR (ipCommand);
	  break;
	case tXOR:
	  cmdXOR (ipCommand);
	  break;
	case tSET:
	  cmdSET (ipCommand);
	  break;
	case tGMODE:
	  cmdGMODE (ipCommand);
	  break;
	case tWSIZE:
	  cmdWSIZE (ipCommand);
	  break;
	case tWMOVE:
	  cmdWMOVE (ipCommand);
	  break;
	case tD:
	  cmdD (ipCommand);
	  break;
	case tM:
	  cmdM (ipCommand);
	  break;
	case tORM:
	  cmdORM (ipCommand);
	  break;
	case tZOOM:
	  cmdZOOM (ipCommand);
	  break;
	case tBOX:
	  cmdBOX (ipCommand);
	  break;
	case tPSET:
	  cmdPSET (ipCommand);
	  break;
	case tPOINT:
	  cmdPOINT (ipCommand);
	  break;
	case tPSETW:
	  cmdPSETW (ipCommand);
	  break;
	case tPOINTW:
	  cmdPOINTW (ipCommand);
	  break;
	case tPAL:
	  cmdPAL (ipCommand);
	  break;
	case tDPAL:
	  cmdDPAL (ipCommand);
	  break;
	case tTONE:
	  cmdTONE (ipCommand);
	  break;
	case tPTONE:
	  cmdPTONE (ipCommand);
	  break;
	case tDISP:
	  cmdDISP (ipCommand);
	  break;
	case tCDISP:
	  cmdCDISP (ipCommand);
	  break;
	case tPCM:
	  cmdPCM (ipCommand);
	  break;
	case tPCML:
	  cmdPCML (ipCommand);
	  break;
	case tPCH:
	  cmdPCH (ipCommand);
	  break;
	case tPCHL:
	  cmdPCHL (ipCommand);
	  break;
	case tPWT:
	  cmdPWT (ipCommand);
	  break;
	case tPST:
	  cmdPST (ipCommand);
	  break;
	case tRATE:
	  cmdRATE (ipCommand);
	  break;
	case tCOUNT:
	  cmdCOUNT (ipCommand);
	  break;
	case tTC:
	  cmdTC (ipCommand);
	  break;
	case tT:
	  cmdT (ipCommand);
	  break;
	case tREADPARA:
	  cmdREADPARA (ipCommand);
	  break;
	case tGETPARA:
	  cmdGETPARA (ipCommand);
	  break;
	case tEND:
	  return False;
	  break;
	default:
	  cerr << "invalid command.is there error?" << endl;
	  break;
	}
#endif
      return True;
    }//for (;;)

  return True;//ǰΤ
}

///////////////////////////////////////////Event Handler
Bool Mms::handleEvent (XEvent event)
{
  switch (event.type)
    {
    case KeyPress:
      do
	{
	  switch(XKeycodeToKeysym (display,event.xkey.keycode,0))
	    {
	    case XK_Escape://Escape keyƤкλ
	      MaslAudio::resetAudio ();//PCMߤ롣
	      return False;
	      break;
	    default://do nothing
	      break;
	    }
	}while (XCheckTypedEvent (display,KeyPress,&event));//;ʬʥ٥Ȥɤ
      break;
    case Expose://̤κ
      while (XCheckTypedEvent (display,Expose,&event))
	;//do nothing ;ʬʥ٥Ȥɤ߼Τ 
      updateWindow ();
      break;
    case ButtonPress:
      switch (event.xbutton.button)
	{
	case 1:
	  {
	    CopyImage2Root copyImage2Root (display,screen,window,
					   planeMask[0]|planeMask[1]|
					   planeMask[2]|planeMask[3]|
					   planeMask[4]|planeMask[5]|
					   planeMask[6]|planeMask[7]);
	    copyImage2Root.copyImage2Root ();
	  }
	break;
	case 2:
	  XIconifyWindow (display,window,screen);
	  break;
	default:
	  break;//⤷ʤ
	}
      break;
    default://ʤΤʤǰΰ
      //⤷ʤ
      break;
    }
  return True;
}

#ifndef USE_OLD_TIMER_WAIT
Bool Mms::waitTimerOrHandleEvent ()
{
  if (!isTimerWaiting)
    {//timerԤǤʤ̾Event Handling
      XEvent event;
      if (XCheckMaskEvent (display,maslEventMask,&event))
	{
	  if (handleEvent (event)==False)
	    return False;
	}
    }
  else
    {///////////////////////////////////////////////timerϢ(timer countԤ)
      /////////////////////////////////////////////////timerԤ
      while (timer.getNowCount ()<(long)timeCntForWait*100)
	{//timerԤʤΤǡ롣
	  XEvent event;
	  while (XCheckMaskEvent (display,maslEventMask,&event))
	    {
	      if (handleEvent (event)==False)
		return False;
	      if (!(timer.getNowCount ()<(long)timeCntForWait*100))
		goto WAIT_IS_OVER;
	    }
#ifdef DEBUG_MODE
	  ////////////////////////////////////////////////////////debug mode
	  if (xmmsOption.isDebugMode)
	    {//debug modedataι(keyԤϤʤ)
	      debugMode->updataParam ();
	      continue;
	    }
#endif //DEBUG_MODE
	  ////////////////////////////////////////////timerԤ
	  /////////////////////////////////xlockmore򻲹ͤˤޤ
	  timeval leftTime=timer.getLeftTimeVal (timeCntForWait*100);
	  int xfd=ConnectionNumber (display);
	  fd_set reads;
	  FD_ZERO (&reads);
	  FD_SET (xfd,&reads);
	  int result=select (xfd+1,&reads,NULL,NULL,&leftTime);

	  if (result==0)
	    break;//time out.timerԤλ
	  if (result==1)
	    continue;//event褿
	  if (result>0 || (result==-1 && errno!=EINTR))
	    cerr << "Unexpected selcet () return value=" << result << endl;
	}

    WAIT_IS_OVER:
      ////////////////////////////////////////timerԤλ
      timeCntForWait=0;
      isTimerWaiting=False;
      if (isDispWaiting)
	{
	  updateWindowByTransferedData ();
	  isDispWaiting=False;
	}
    }

  return True;
}
#endif //USE_OLD_TIMER_WAIT
