/* 
        testNak.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>

#include "MmsConst.h"
#include "Mms.h"

main (int argc,char** argv)
{
  XMMS_OPTION xmmsOption=XMMS_OPTION ();

  static String fallbackResources[]=
  {
    NULL,
  };
  
  XtAppContext appContext;
  Widget topLevel;
  XtToolkitInitialize ();
  topLevel=XtVaAppInitialize (&appContext,APP_CLASS_NAME,NULL,ZERO,
			      &argc,argv,fallbackResources,
			      XtNwidth, VIRTUAL_VRAM_SIZE_X,
			      XtNheight,VIRTUAL_VRAM_SIZE_Y,NULL);
  Display* display=XtDisplay (topLevel);
  if (display==NULL)
    {//X serverȤ³ʤä
      cerr << "Error Can not connect X server." << endl;
      exit (-1);
    }
  Mms mms=Mms (display,argc,argv,argv[1],xmmsOption);
  
  cout << "mms.numberOfNak=" << mms.numberOfNak << endl;
  cout << "mms.numberOfMmsPalette=" << mms.numberOfMmsPalette << endl;
  cout << "mms.numberOfPcm=" << mms.numberOfPcm << endl;
  for (int i=0;i<mms.numberOfMmsPalette;i++)
    {
      cout << i << "-th MmsPalette" << endl;
      mms.pMmsPalette[i]->printData ();
    }
  mms.pMmsPalette[0]->setPalette (mms.pMmsPalette[0]->offset);
  XFlush (mms.display);
  
  unsigned char* imageData=new unsigned char[VIRTUAL_VRAM_LENGTH];
  memset (imageData,0,VIRTUAL_VRAM_LENGTH);//memory 

  GraphicMode graphicMode=GM640x480;
  //GraphicMode graphicMode=GM640x400;
  //GraphicMode graphicMode=GM320x240;
  //GraphicMode graphicMode=GM320x200;
  mms.mmsWindow->setGraphicMode (graphicMode);
  mms.mmsWindow->setWindowSize (0,0,640,480);
  mms.mmsWindow->moveWindow (0,0);
  for (int i=0;i<mms.numberOfNak;i++)
    {
      cout << i << "-th image:area=(" 
	   << mms.pNak[i]->left << "," << mms.pNak[i]->top << ")-("
	   << mms.pNak[i]->right << "," << mms.pNak[i]->bottom << ")"
	   << endl;
      memset (imageData,0,VIRTUAL_VRAM_LENGTH);//memory 
      mms.pNak[i]->extractNak2Vram (imageData);
      mms.mmsWindow->updateWindow (imageData);
      XFlush (mms.display);

      for (;;)
        {
          XEvent event;
          XNextEvent (display,&event);
          if (event.type==ButtonPress||event.type==KeyPress)
            break;
	  mms.mmsWindow->updateWindow (imageData);
	  XFlush (mms.display);
        }
    }

  if (!(Audio::openAudioDevice ()))
    {
      cerr << "can not open audio device." << endl;
      exit (-1);
    }

  MaslAudio::prepareMaslAudio (&mms.isAudioWriting,&mms.isAudioWaiting);
  if (mms.numberOfPcm>0)
    {
      if (!(Audio::initializeAudioDevice ((mms.pPcm[0]->PcmRate))))
	{
	  cerr << "can not initialize audio device." << endl;
	  exit (-1);
	}
      for (int i=0;i<mms.numberOfPcm;i++)
	{
	  cout << i << "-th ADPCM" << endl;
	  cout << "rate=" << mms.pPcm[i]->PcmRate 
	       << ".now playing..." << flush;
	  mms.pPcm[i]->play ();
	  Audio::sync ();
	  cout << "done." << endl;
	  //getchar ();
	}

    }
  Audio::closeAudioDevice ();
}
