/* 
        xmm.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        codeshimarincode򸵤YamahataΤǤ

*/
#include <iostream.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>

#include "MmsConst.h"
#include "Mms.h"

static void printUsage ();
static void analyseXmmsOption (const char* const,XMMS_OPTION* xmmsOption);

int
main (int __argc,char** const __argv)
{
  int mmsFileOffset=1;
  char mmsSuffix[]=".mms";
  char MMSSuffix[]=".MMS";
  while (mmsFileOffset<__argc)
    {/* *.mmsܤ˻ꤵƤ뤫Ĵ٤롣*/
      if (strcmp (__argv[mmsFileOffset]+strlen (__argv[mmsFileOffset])-4,
		  mmsSuffix)==0 ||
	  strcmp (__argv[mmsFileOffset]+strlen (__argv[mmsFileOffset])-4,
		  MMSSuffix)==0)
	break;
      mmsFileOffset++;
    }
  if (mmsFileOffset==__argc)
    {
      cerr << "no *.mms file is specified." << endl;
      printUsage ();
      exit (-1);
    }
  
  ///////////////////////////////////////////////resouce & option
  static String fallbackResources[]=
  {
    NULL,
  };
  
  static XtResource resources[]=
  {
#ifdef MITSHM
    {"isUseMITSHM","IsUseMITSHM",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isUseMITSHM),
     XtRImmediate,(XtPointer)False},
#endif
    {"isStatic","IsStatic",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isStatic),
     XtRImmediate,(XtPointer)False},
    {"isTraceMode","IsTraceMode",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isTraceMode),
     XtRImmediate,(XtPointer)False},
    {"isNoSound","IsNoSound",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isNoSound),
     XtRImmediate,(XtPointer)False},
    {"isNoPrintComment","IsNoPrintComment",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isNoPrintComment),
     XtRImmediate,(XtPointer)False},
    {"isWaitBeforePlaying","IsWaitBeforePlaying",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isWaitBeforePlaying),
     XtRImmediate,(XtPointer)False},
    {"isPause","IsPause",
     XtRBool,sizeof (XtRBool)
     ,XtOffset (class XMMS_OPTION*,isPause),
     XtRImmediate,(XtPointer)False},
    {"isWindowResizable","IsWindowResizable",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isWindowResizable),
     XtRImmediate,(XtPointer)False},
    {"isSjis","IsSjis",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isSjis),
     XtRImmediate,(XtPointer)False},
#ifdef RENICE
    {"isRenice","IsRenice",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isRenice),
     XtRImmediate,(XtPointer)False},
#endif
#ifdef DEBUG_MODE
    {"isDebugMode","IsDebugMode",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isDebugMode),
     XtRImmediate,(XtPointer)False},
    {"iBreakMode","IsBreakMode",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isBreakMode),
     XtRImmediate,(XtPointer)False},
/* äƤɤꤷ餤ΤǤ礦?
    {"ttyOfDebugMode","TtyOfDebugMode",
     XtRChar*,sizeof (char*),
     XtOffset (class XMASL_OPTION*,ttyOfDebugMode),
     XtRImmediate,(XtPoint)NULL},
     */
#endif
    {"isShowVram","IsShowVram",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isShowVram),
     XtRImmediate,(XtPointer)False},
    {"isShowVirtualVram","IsShowVirtualVram",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isShowVirtualVram),
     XtRImmediate,(XtPointer)False},
    {"isReduction","IsReduction",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isReduction),
     XtRImmediate,(XtPointer)False},
    {"isShowVirtualWindowFrame","IsShowVirtualWindowFrame",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isShowVirtualWindowFrame),
     XtRImmediate,(XtPointer)False},
    {"isFullMotion","IsFullMotion",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isFullMotion),
     XtRImmediate,(XtPointer)False},
    {"isPrivateColormapCreated","IsPrivateColormapCreated",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMMS_OPTION*,isPrivateColormapCreated),
     XtRImmediate,(XtPointer)False},
  };

  XMMS_OPTION xmmsOption=XMMS_OPTION ();
  XtAppContext appContext;
  Widget topLevel;
  int optionNumber=mmsFileOffset-1;
/*
  XtToolkitInitialize ();
  appContext=XtCreateApplicationContext ();
  Display* display=XtOpenDisplay (appContext,(String)NULL,NULL,APP_CLASS_NAME,
                                  NULL,ZERO,&optionNumber,__argv);
  XtVaGetSubvalues ((caddr_t)&xmaslOption,resources,XtNumber (resources),NULL);
*/
  topLevel=XtVaAppInitialize (&appContext,APP_CLASS_NAME,NULL,ZERO,
			      &optionNumber,__argv,fallbackResources,
			      XtNwidth,WINDOW_SIZE_X,
			      XtNheight,WINDOW_SIZE_Y,NULL);
  XtVaGetApplicationResources (topLevel,(caddr_t)&xmmsOption,
			       resources,XtNumber (resources),NULL);

  Display* display=XtDisplay (topLevel);
  if (display==NULL)
    {//X serverȤ³ʤä
      cerr << "Error Can not connect X server." << endl;
      exit (-1);
    }

  for (int i=1;i<mmsFileOffset;i++)
  {
    if (__argv[i]==NULL)
      continue;//˾ǻѺѤ
    analyseXmmsOption (__argv[i],&xmmsOption);    
  }
  
#if 0
  int i=1;
  while (__argv[i]==NULL || __argv[i][0]=='-')
    {
      if (__argv[])
      analyseXmmsOption (__argv[i],&xmmsOption);
      i++;
      if (i==__argc)
	{/* *.msl fileꤵƤ뤫check */
	  cerr << "no *.mms file is specified." << endl;
	  printUsage ();
	  exit (-1);
	}
    }
#endif

  /////////////////////////////////////////////////////////dataload
  Mms mms=Mms(display,
	      __argc-mmsFileOffset,__argv+mmsFileOffset,
	      __argv[mmsFileOffset],xmmsOption);

  /////////////////////////////////////////////////////////dataκ
  mms.preparePlay ();
  while (mms.play ())
    {
      //⤷ʤ
    }
  mms.afterPlay ();

  //////////////////////////////////////////////////////////
  XtDestroyWidget (topLevel);
}

////////////////////////////option handler
#ifdef MITSHM
static void optionUseMITSHM (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isUseMITSHM=True;
}
#endif

static void optionStatic(XMMS_OPTION* xmmsOption)
{
  xmmsOption->isStatic=True;
}

static void optionRealtimeDecode (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isStatic=False;
}

static void optionNoSound (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isNoSound=True;
}

static void optionSound (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isNoSound=False;
}

static void optionTraceMode (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isTraceMode=True;
}

static void optionComment (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isNoPrintComment=False;
}

static void optionNoPrintComment (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isNoPrintComment=True;
}

static void optionHelp (XMMS_OPTION* xmmsOption)
{
  printUsage ();
  exit (0);
}

static void optionWait (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isWaitBeforePlaying=True;
}

static void optionPause (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isPause=True;
}

static void optionWindowResizable (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isWindowResizable=True;
}

static void optionSjis (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isSjis=True;
}

static void optionEuc (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isSjis=False;
}

static void optionShowVram (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isShowVram=True;
}

static void optionShowVirtualVram (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isShowVirtualVram=True;
}

static void optionReduction (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isReduction=True;
}

#ifdef RENICE
static void optionRenice (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isRenice=True;
}
#endif //RENICE

static void optionNormalMode (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isTraceMode=False;
#ifdef DEBUG_MODE
  xmmsOption->isDebugMode=False;  
  xmmsOption->isBreakMode=False;
#endif //DEBUG_MODE
}
#ifdef DEBUG_MODE
static void optionDebugMode (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isDebugMode=True;
}

static void optionBreakMode (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isBreakMode=True;
}
#endif //DEBUG_MODE

static void optionFullMotion (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isFullMotion=True;
}

static void optionIsUsePrivateColormap (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isPrivateColormapCreated=True;
}

static void optionShowVirtualWindowFrame (XMMS_OPTION* xmmsOption)
{
  xmmsOption->isShowVirtualWindowFrame=True;
}

struct XmmsOption
{
  char* optionName;
  void (*setOption) (XMMS_OPTION* xmmsOption);
};

XmmsOption xmmsOptionTable[]=
{
#ifdef DEBUG_MODE
  {"-break",optionBreakMode},
  {"b",optionBreakMode},
#endif//DEBUG_MODE
  {"-comment",optionComment},//commentɽ
  {"c",optionNoPrintComment},
  {"-commentless",optionNoPrintComment},//commentɽʤ
#ifdef DEBUG_MODE
  {"-debug",optionDebugMode},
  {"d",optionDebugMode},
#endif//DEBUG_MODE
  {"-euc",optionEuc},//commenteucɽ롣
  {"e",optionEuc},//commenteucɽ롣
  {"-fullmotion",optionFullMotion},//ƤƤ⥳ޤФʤ
  {"f",optionFullMotion},
  {"-help",optionHelp},//usageɽ
  {"h",optionHelp},
#ifdef MITSHM
  {"-mitshm",optionUseMITSHM},
  {"m",optionUseMITSHM},
#endif//MITSHM
  {"-normal",optionNormalMode},//normal node
  {"-nosound",optionNoSound},//PCM̵
  {"n",optionNoSound},
  {"-pause",optionPause},//λkeyԤ򤹤
  {"-privatecolormap",optionIsUsePrivateColormap},
  {"p",optionIsUsePrivateColormap},
#ifdef RENICE
  {"-RENICE",optionRenice},//processμ¹̤ͥ夲롣
  {"R",optionRenice},
#endif//RENICE
  {"-resizable",optionWindowResizable},//windowsizeѹǧ롣
  {"-realtime",optionRealtimeDecode},//ŸưŪ˹Ԥʤ
  {"-reduction",optionReduction},//320x200,320x240mode˳Ԥʤʤ
  {"r",optionReduction},//320x200,320x240mode˳Ԥʤʤ
  {"-static",optionStatic},//Ūcg dataŸ뤫
  {"s",optionStatic},
  {"-sound",optionSound},//soundonˤ롣
  {"-sjis",optionSjis},
  {"-trace",optionTraceMode},//trace mode(mode)
  {"t",optionTraceMode},
  {"-VRAM",optionShowVram},//;ʬwindow򳫤vramɽ롣
  {"V",optionShowVram},//;ʬwindow򳫤vramɽ롣
  {"-vram",optionShowVirtualVram},//̾window˲vramɽ롣
  {"v",optionShowVirtualVram},//̾window˲vramɽ롣
  {"-wait",optionWait},//ϻkeyԤ򤹤
  {"w",optionWait},
  {"-window",optionShowVirtualWindowFrame},
};

#define MAX_OPTIONS ((int) (sizeof (xmmsOptionTable)/sizeof (XmmsOption)))

////////////////////////////////////////////invalid option
static void printInvalidOption(const char* const option)
{	      
  cerr << "invalid option:" << option << endl;
  printUsage ();
  exit (-1);
}

///////////////////////////////ºݤoptionꤹ롣
static void analyseXmmsOption
(const char* const option,XMMS_OPTION* xmmsOption)
{
  if (option[1]=='-')
    {//long style(--hoegehogeη)
      for (int i=0;i<MAX_OPTIONS;i++)
	{
	  if (strcmp (xmmsOptionTable[i].optionName,option+1)==0)
	    {
	      xmmsOptionTable[i].setOption (xmmsOption);
	      return;
	    }
	}
      //option̵ä
      printInvalidOption (option);//comment outɤʡ
    }
  else
    {//short style(-hogehogeη)
      for (int j=1;j<(int) strlen (option);j++)
	{
	  int i=0;
	  while (i<MAX_OPTIONS)
	    {
	      if (*(xmmsOptionTable[i].optionName)==*(option+j) &&
		  *(xmmsOptionTable[i].optionName)!='-')//long style̵
		{
		  xmmsOptionTable[i].setOption (xmmsOption);
		  break;
		}
	      i++;
	    }
	  if (i==MAX_OPTIONS)
	    {//option̵ä
	      printInvalidOption (option);//comment outɤʡ
	    }
	}
      return;
    }
}

////////////////////////////////////////////erroro
static void printUsage ()
{
  cerr << "Usage:xmm [options] filename [scenario-options]"<< endl;
  //cerr << "scenario-options are "
  cerr << "options:" << endl;
#ifdef DEBUG_MODE
  cerr << "-b,--break:break mode when debug mode" << endl;
#endif
  cerr << "-c,--comment:print comment" << endl;
  cerr << "--commentless:print no comment" << endl;
#ifdef DEBUG_MODE
  cerr << "-d,--debug:debug mode" << endl;
#endif
  cerr << "-e,--euc:output comment by Japanese EUC code" << endl;
  cerr << "-f,--fullmotion:display all frames even if behind time" << endl;
  cerr << "-h,--help:print this message and exit" << endl;
#ifdef MITSHM
  cerr << "-m,--mitshm:use MITSHM extention" << endl;
#endif//MITSHM
  cerr << "--normal:play data normaly(disable debug mode)" << endl;
  cerr << "-n,--nosound:play with no sound" << endl;
  cerr << "--pause:wait for keypressing when playing finished" << endl;
  cerr << "-p,--privatecolormap:use private colormap" << endl;
#ifdef RENICE
  cerr << "-R,--RENICE:raise priority" << endl;
#endif
  cerr << "-r,--reduction:display half size when 320x200,320x240" << endl;
  cerr << "--resizable:enable resize window" << endl;
  cerr << "--realtime:realtime decode graphic data" << endl;
  cerr << "-s,--static:statically decode graphic data" << endl;
  cerr << "--sjis:output comment by sjis code" << endl;
  cerr << "--sound:play with sound" << endl;
  cerr << "-t,--trace:trace mode" << endl;
  cerr << "-V,--VRAM:show virtual vram on another window" << endl;
  cerr << "-v,--vram:show virtual vram" << endl;
  cerr << "-w,--wait:wait for keys before playing" << endl;
  cerr << "--window:show frame of virtual window" << endl;
}
